(*
 * iocp c/s ϢװԪ
 *)
unit iocp_msgPacks;

interface

{$I in_iocp.inc}

uses
  {$IFDEF DELPHI_XE7UP}
  Winapi.Windows, System.Classes, System.SysUtils,
  System.Variants, Datasnap.Provider, {$ELSE}
  Windows, Classes, SysUtils, Variants, Provider, {$ENDIF}
  iocp_winSock2, iocp_md5, iocp_mmHash,
  iocp_zlib, iocp_base, iocp_lists,
  iocp_baseObjs;

type

  { TMemBuffer: Զڴ }

  TMemBuffer = Pointer;

  // ================ չڴ ================
  // Դⲿڴ飬д

  TInMemStream = class(TMemoryStream)
  private
    FSetMode: Boolean;   // ڴģʽ
    FNewSize: Longint;   // ڴ泤
  protected
    function Realloc(var NewCapacity: Longint): Pointer; override;
  public
    procedure Clear;
    procedure Initialize(ASize: Cardinal; AddTag: Boolean);
    procedure SetMemory(ABuffer: Pointer; ASize: Longint);
  end;

  // ================== ļչ  ======================
  //  ļ TFileStream Ĳͬ
  //  Զɾʱļο THandleStream

  TReceivePack = class;

  TIOCPDocument = class(THandleStream)
  private
    FTempFile: Boolean;        // ʱļ
    FOriginSize: TFileSize;    // ļȣرպã
    FCreationTime: TFileTime;  // ʱ
    FAccessTime: TFileTime;    // ʱ
    FLastWriteTime: TFileTime; // ޸ʱ
    procedure InternalCreate(const AFileName: String; CreateNew: Boolean);
  protected
    FFileName: String;         // ļ
    procedure RenameDoc(var AFileName: String);
    procedure SetFileInf(Params: TReceivePack);
  public
    constructor Create(const AFileName: String = ''; CreateNew: Boolean = False);
    constructor CreateEx(const AFileName: String);
    destructor Destroy; override;
    procedure Close(DeleFile: Boolean = False);    
  public
    property FileName: String read FFileName;
    property OriginSize: TFileSize read FOriginSize;
  end;

  // ================== ֶζ  ======================

  // /ֶζ(ַ AnsiSting)

  TBasePack = class;

  TVarField = class(TObject)
  private
    FName: AnsiString;     // 
    FData: TListVariable;  // ݴϢ
    function FieldSpace: Integer; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetDataRef: Pointer; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetIsNull: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetSize: Integer; {$IFDEF USE_INLINE} inline; {$ENDIF}
    procedure InterClear;
    procedure InterSetBuffer(AEleType: TElementType; ABuffer: PAnsiChar; ASize: Integer);
    procedure InterSetStream(AEleType: TElementType; ABuffer: PAnsiChar; ASize: Integer);    
  protected
    //  =======================
    function GetAsBoolean: Boolean;
    function GetAsInteger: Integer;
    function GetAsCardinal: Cardinal;
    function GetAsInt64: Int64;
    function GetAsFloat: Double;
    function GetAsDateTime: TDateTime;
    function GetAsObject: TObject;
    function GetAsString: AnsiString;
    // BufferRecordStream ʱ
    function GetAsBuffer: TMemBuffer;
    function GetAsRecord: TBasePack;
    function GetAsStream: TStream;
    // Variant 
    function GetAsVariant: Variant;
  protected
    // д =======================
    procedure SetAsBoolean(const Value: Boolean);
    procedure SetAsInteger(const Value: Integer);
    procedure SetAsCardinal(const Value: Cardinal);
    procedure SetAsInt64(const Value: Int64);
    procedure SetAsFloat(const Value: Double);
    procedure SetAsDateTime(const Value: TDateTime);
    procedure SetAsString(const Value: AnsiString);
    //  BufferRecordStream
    procedure SetAsBuffer(const Value: TMemBuffer);
    procedure SetAsRecord(const Value: TBasePack);
    procedure SetAsStream(const Value: TStream);
  public
    constructor Create(AName: AnsiString);
    destructor Destroy; override;
    property DataRef: Pointer read GetDataRef;
    property Name: AnsiString read FName;
    property IsNull: Boolean read GetIsNull;
    property VarType: TElementType read FData.EleType;
    property Size: Integer read GetSize;
  public
    property AsBoolean: Boolean read GetAsBoolean;
    property AsBuffer: TMemBuffer read GetAsBuffer;
    property AsCardinal: Cardinal read GetAsCardinal;
    property AsDateTime: TDateTime read GetAsDateTime;
    property AsFloat: Double read GetAsFloat;
    property AsInteger: Integer read GetAsInteger;
    property AsInt64: Int64 read GetAsInt64;
    property AsObject: TObject read GetAsObject;
    property AsRecord: TBasePack read GetAsRecord;
    property AsStream: TStream read GetAsStream;
    property AsString: AnsiString read GetAsString;
    property AsVariant: Variant read GetAsVariant; // 
  end;

  // ================== Ϣ  ======================
  //  <->  δԣֱʹ

  TBasePack = class(TObject)
  private
    FError: Boolean;     // 
  protected
    FList: TInList;      // б
    FSize: Cardinal;     // ȫݳ
  private
    function GetCount: Integer;
    function GetFields(Index: Integer): TVarField;
    function GetSize: Cardinal; virtual;

    // ұ/ֶ
    function FindField(VarName: AnsiString; var Field: TVarField): Boolean;

    // дֶݵڴ
    procedure WriteBuffers(const Buf: Pointer);
  protected
    // ñֵ
    procedure SetField(EleType: TElementType; const VarName: AnsiString;
                       const Value: PListVariable; const SValue: AnsiString = '');

    // ƵĺϷ
    procedure CheckFieldName(const Value: AnsiString); virtual;

    // ݵĺϷ
    procedure CheckStringValue(const Value: AnsiString); virtual;

    // ڴ
    procedure SaveToMemStream(Stream: TMemoryStream); virtual;

    // ɨڴ飬
    procedure ScanBuffers(ABuffer: PAnsiChar; ASize: Cardinal); virtual;

    // ֶתΪ JSON
    procedure VarToJSON(var Buf: PAnsiChar; const VarName, VarValue: AnsiString;
                        Digital: Boolean; FirstPos: Boolean = False; EndPos: Boolean = False);
  protected
    //  =======================
    function GetAsBoolean(const Index: String): Boolean;
    function GetAsInteger(const Index: String): Integer;
    function GetAsCardinal(const Index: String): Cardinal;
    function GetAsInt64(const Index: String): Int64;
    function GetAsFloat(const Index: String): Double;
    function GetAsDateTime(const Index: String): TDateTime;

    function GetAsDocument(const Index: String): String;
    function GetAsString(const Index: String): String;

    // BufferRecordStream ʱ
    function GetAsBuffer(const Index: String): TMemBuffer;
    function GetAsRecord(const Index: String): TBasePack;
    function GetAsStream(const Index: String): TStream;
    function GetAsVariant(const Index: String): Variant;
  protected
    // д =======================
    procedure SetAsBoolean(const Index: String; const Value: Boolean);
    procedure SetAsInteger(const Index: String; const Value: Integer);
    procedure SetAsCardinal(const Index: String; const Value: Cardinal);
    procedure SetAsInt64(const Index: String; const Value: Int64);
    procedure SetAsFloat(const Index: String; const Value: Double);
    procedure SetAsDateTime(const Index: String; const Value: TDateTime);

    procedure SetAsDocument(const Index: String; const Value: String);
    procedure SetAsString(const Index: String; const Value: String);

    //  BufferRecordStream
    procedure SetAsBuffer(const Index: String; const Value: TMemBuffer);
    procedure SetAsRecord(const Index: String; const Value: TBasePack);
    procedure SetAsStream(const Index: String; const Value: TStream);
    procedure SetAsVariant(const Index: String; const Value: Variant);
  protected
    property AsBoolean[const Index: String]: Boolean read GetAsBoolean write SetAsBoolean;
    property AsBuffer[const Index: String]: TMemBuffer read GetAsBuffer write SetAsBuffer;
    property AsCardinal[const Index: String]: Cardinal read GetAsCardinal write SetAsCardinal;
    property AsDateTime[const Index: String]: TDateTime read GetAsDateTime write SetAsDateTime;
    property AsDocument[const Index: String]: String read GetAsDocument write SetAsDocument;
    property AsFloat[const Index: String]: Double read GetAsFloat write SetAsFloat;
    property AsInteger[const Index: String]: Integer read GetAsInteger write SetAsInteger;
    property AsInt64[const Index: String]: Int64 read GetAsInt64 write SetAsInt64;
    property AsRecord[const Index: String]: TBasePack read GetAsRecord write SetAsRecord;
    property AsStream[const Index: String]: TStream read GetAsStream write SetAsStream;
    property AsString[const Index: String]: String read GetAsString write SetAsString;
    property AsVariant[const Index: String]: Variant read GetAsVariant write SetAsVariant;
  public
    constructor Create;
    destructor Destroy; override;
  public  
    procedure Clear; virtual;
    procedure Initialize(Stream: TStream; ClearIt: Boolean = True); overload;
    procedure Initialize(const AFileName: String); overload;
    procedure SaveToFile(const AFileName: String);
    procedure SaveToStream(Stream: TStream; DelParams: Boolean = True);
  public
    property Count: Integer read GetCount;
    property Document[const index: String]: TStream read GetAsStream;
    property Fields[index: Integer]: TVarField read GetFields;
    property Error: Boolean read FError write FError;
    property Size: Cardinal read GetSize;
  end;

  // ================== ûϢ  ======================
  // TBasePack ʹʽ

  TCustomPack = class(TBasePack)
  public
    property AsBoolean;
    property AsBuffer;
    property AsCardinal;
    property AsDateTime;
    property AsDocument;
    property AsFloat;
    property AsInteger;
    property AsInt64;
    property AsRecord;
    property AsString;
    property AsStream;
  end;

  // ================== ЭϢ  ======================
  // Эͷա
  // Ԥ賣ñ/ԵĶдҪ

  THeaderPack = class(TBasePack)
  protected
    // ======== Ԫ TMsgHead ֶһ ==========
    FOwner: TMessageOwner;      // ߣ
    FSessionId: Cardinal;       // ֤/¼ ID
    FMsgId: TIOCPMsgId;         // Ϣ ID
    FDataSize: Cardinal;        // Ϣԭʼȣ壩
    FAttachSize: TFileSize;     // ļȣ
    FOffset: TFileSize;         // ϵλ
    FOffsetEnd: TFileSize;      // ϵĽλ
    FCheckType: TDataCheckType; // У
    FVarCount: Cardinal;        // Ϣı/Ԫظ
    FZipLevel: TZipLevel;       // ѹ
    FTarget: TActionTarget;     // ĿĶ
    FAction: TActionType;       // 
    FActResult: TActionResult;  // 
    // ==================================================
  protected
    FMain: TInMemStream;        // 
    procedure ToRecord(var ABuffer: PAnsiChar; var ASize: Cardinal);
  protected
    function GetAttachFileName: String;   // ļȫ
    function GetConnection: Integer;      // ӱ
    function GetDateTime: TDateTime;      // ȡʱ
    function GetDirectory: String;        // ·
    function GetFileName: String;         // ļ
    function GetFileSize: TFileSize;      // ļС
    function GetFunctionGroup: string;    // Զ̺
    function GetFunctionIndex: Integer;   // Զ̺
    function GetHasParams: Boolean;       // SQL Ƿ
    function GetLocalPath: string;        // ȡļ·
    function GetMsg: String;              // Ϣ
    function GetNewFileName: String;      // µļ
    function GetPassword: String;         // /
    function GetPeerIPPort: String;       // ͻ IP:Port
    function GetReuseSessionId: Boolean;  // Ƿƾ֤
    function GetRole: TClientRole;        // ɫ/Ȩ
    function GetSize: Cardinal; override; // ȫĿռС
    function GetSQL: String;              // SQL ı
    function GetSQLName: String;          // SQL ƣԤ裩
    function GetStoredProcName: String;   // 洢
    function GetToUser: String;           // Ŀû
    function GetURL: String;              //  URL
    function GetUserName: String;         // ûԴ
  protected
    procedure SetAttachFileName(const Value: String);
    procedure SetConnection(const Value: Integer);
    procedure SetDateTime(const Value: TDateTime);
    procedure SetDirectory(const Value: String);
    procedure SetFileName(const Value: String);
    procedure SetFileSize(const Value: TFileSize);
    procedure SetFunctionGroup(const Value: String);
    procedure SetFunctionIndex(const Value: Integer);
    procedure SetHasParams(const Value: Boolean);
    procedure SetLocalPath(const Value: String);
    procedure SetMsg(const Value: String);
    procedure SetNewFileName(const Value: String);
    procedure SetPassword(const Value: String);
    procedure SetPeerIPPort(const Value: String);
    procedure SetReuseSessionId(const Value: Boolean);
    procedure SetRole(const Value: TClientRole);
    procedure SetSQL(const Value: String);
    procedure SetSQLName(const Value: String);
    procedure SetStoredProcName(const Value: String);
    procedure SetToUser(const Value: String);
    procedure SetURL(const Value: String);
    procedure SetUserName(const Value: String);
  public
    function  ToJSON: AnsiString;
    function  GetMsgSize(RecvMode: Boolean): TFileSize;
    procedure GetHeadMsg(Msg: PMsgHead);
    procedure SetHeadMsg(Msg: PMsgHead; ForReturn: Boolean = False);
  public
    // 
    property AsBoolean;
    property AsBuffer;
    property AsCardinal;
    property AsDateTime;
    property AsDocument;
    property AsFloat;
    property AsInteger;
    property AsInt64;
    property AsRecord;
    property AsString;
    property AsStream;
    property AsVariant;
  end;

  // ================== յϢ  ======================
  // ˡͻյϢֻ
   
  TReceivePack = class(THeaderPack)
  private
    FAttachment: TIOCPDocument; // 
  protected
    procedure CreateAttachment(const ALocalPath: String); virtual;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Cancel;
    procedure Clear; override;
    procedure Write(AData: PPerIOData);
  public
    // 
    property Main: TInMemStream read FMain;
    property Attachment: TIOCPDocument read FAttachment write FAttachment;
  public
    // Эͷ
    property Action: TActionType read FAction;
    property ActResult: TActionResult read FActResult;
    property AttachSize: TFileSize read FAttachSize;
    property CheckType: TDataCheckType read FCheckType;
    property DataSize: Cardinal read FDataSize;
    property MsgId: TIOCPMsgId read FMsgId;
    property Offset: TFileSize read FOffset;
    property OffsetEnd: TFileSize read FOffsetEnd;
    property Owner: TMessageOwner read FOwner;
    property SessionId: Cardinal read FSessionId;
    property Target: TActionTarget read FTarget;
    property VarCount: Cardinal read FVarCount;
    property ZipLevel: TZipLevel read FZipLevel;
  public
    // ñ/
    property Connection: Integer read GetConnection;
    property DateTime: TDateTime read GetDateTime;
    property Directory: String read GetDirectory;
    property FileName: String read GetFileName;
    property FromUser: String read GetUserName;
    property FunctionGroup: String read GetFunctionGroup;
    property FunctionIndex: Integer read GetFunctionIndex;
    property HasParams: Boolean read GetHasParams;
    property Msg: String read GetMsg;
    property NewFileName: String read GetNewFileName;
    property Password: String read GetPassword;
    property PeerIPPort: String read GetPeerIPPort;
    property ReuseSessionId: Boolean read GetReuseSessionId;
    property Role: TClientRole read GetRole;
    property StoredProcName: String read GetStoredProcName;
    property SQL: String read GetSQL;
    property SQLName: String read GetSQLName;
    property TargetUser: String read GetToUser;
    property ToUser: String read GetToUser;
    property URL: String read GetURL;
    property UserName: String read GetUserName;
  end;

  // Ϣ
  TReceivePackClass = class of TReceivePack;

  // ================== Ϣ  ======================
  // ˡͻ˷ãд

  // Ϣࣺ
  // 1. 壺1.1 As... ϵеıݣFVarCount > 0
  //          1.2 Variant ݼݣFVarCount = 0
  // 2. ļݼ߻

  // ͷ
  // 1. ȷ壬󷢸
  // 2. ͻ˷͸󣬵ȴ˷ٷ
  // 3. ˷͸ֱӷ

  // ݸʽ
  //   װIOCP_HEAD_FLAG + TMsgHead + [У + У] + [ԭʼ]
  // [򸽼ԭʼ]

  TBaseMessage = class(THeaderPack)
  protected
    FAttachFileName: String; // ļ
    FAttachment: TStream;    // 
    FAttachZiped: Boolean;   // Ƿѹ
  private
    procedure GetCheckCode(AStream: TStream; ToBuf: PAnsiChar;
                           ASize: TFileSize; var Offset: Cardinal);
    procedure InterSetAttachment(AStream: TStream);
  protected
    procedure AdjustTransmitRange(ChunkSize: Integer);
    procedure CreateStreams(ClearList: Boolean = True); virtual;
    procedure GetFileInfo(const AFileName: String);
    procedure LoadFromVariant(const AProviders: array of TDataSetProvider;
                              const ATableNames: array of String); overload; virtual; // ͻ˲
    procedure LoadHead(Data: PWsaBuf);
    procedure NilStreams(CloseAttachment: Boolean);
    procedure OpenLocalFile; virtual;
    class procedure CreateHead(ABuf: PAnsiChar; AResult: TActionResult);
  public
    constructor Create(AOwner: TObject);
    destructor Destroy; override;
    procedure Clear; override;
    procedure LoadFromFile(const AFileName: String; ServerMode: Boolean = False); virtual; 
    procedure LoadFromStream(AStream: TStream; AZipCompressIt: Boolean = False);
  public
    // 
    property Main: TInMemStream read FMain;
    property Attachment: TStream read FAttachment;
  public
    // ˡͻ˳ԣд
    property AttachFileName: String read FAttachFileName;
    property DateTime: TDateTime read GetDateTime write SetDateTime;
    property FromUser: String read GetUserName write SetUserName;
    property Msg: String read GetMsg write SetMsg;
    property PeerIPPort: String read GetPeerIPPort write SetPeerIPPort;
    property Role: TClientRole read GetRole write SetRole;
    property TargetUser: String read GetToUser write SetToUser;
    property ToUser: String read GetToUser write SetToUser;
    property UserName: String read GetUserName write SetUserName;
  end;

  // ================== Ϣ  ======================

  TMessageWriter = class(TObject)
  private
    FLock: TThreadLock;    // Ϣ
    FSurportHttp: Boolean; // ɸ URL
  public
    constructor Create(SurportHttp: Boolean);
    destructor Destroy; override;
  public
    procedure LoadMsg(const UserName: String; Msg: TBaseMessage);
    procedure SaveMsg(Data: PPerIOData; const ToUser: String); overload;
    procedure SaveMsg(Msg: THeaderPack; const ToUser: String); overload;
  end;

  // ================== ͻϢĶ  ======================

  TMessageReader = class(TObject)
  private
    FHandle: THandle;  // ļ
    FCount: Integer;   // Ϣ
  public
    destructor Destroy; override;
    procedure Close;
    function Extract(Msg: TReceivePack; LastMsgId: TIOCPMsgId = 0): Boolean;
    procedure Open(const FileName: String);
  public
    property Count: Integer read FCount;
  end;
    
// Զڴ, ṹSize + Content
function GetBuffer(const Value: Integer): TMemBuffer;
function FreeBuffer(P: TMemBuffer): Integer;
function BufferSize(P: TMemBuffer): Integer;

implementation

uses
  iocp_log, iocp_varis, iocp_utils, http_utils;

function GetBuffer(const Value: Integer): TMemBuffer;
begin
  if (Value > 0) then
  begin
    GetMem(Result, Value + SizeOf(Integer));
    PInteger(Result)^ := Value;  // һ Integer Ϊ
    Inc(PAnsiChar(Result), SizeOf(Integer));  // صڶԪصַ
  end else
    Result := Nil;
end;

function FreeBuffer(P: TMemBuffer): Integer;
begin
  Dec(PAnsiChar(P), SizeOf(Integer));  // һ Integer λ
  Result := PInteger(P)^;
  FreeMem(P);
end;

function BufferSize(P: TMemBuffer): Integer;
begin
  Dec(PAnsiChar(P), SizeOf(Integer));  // һ Integer λ
  Result := PInteger(P)^;
end;

{ TInMemStream }

procedure TInMemStream.Clear;
begin
  if Assigned(Memory) then
    inherited Clear;
end;

procedure TInMemStream.Initialize(ASize: Cardinal; AddTag: Boolean);
begin
  // ܳ
  if AddTag then
  begin
    //  1 ֽڣ Http бָ&,
    Size := ASize + 1;
    PAnsiChar(LongWord(Memory) + ASize)^ := AnsiChar('&'); 
  end else
    Size := ASize;
  Position := 0;
end;

function TInMemStream.Realloc(var NewCapacity: Integer): Pointer;
begin
  if FSetMode then
  begin
    Result := Memory;
    NewCapacity := FNewSize;
  end else
    Result := inherited Realloc(NewCapacity);
end;

procedure TInMemStream.SetMemory(ABuffer: Pointer; ASize: Integer);
begin
  // ⲿڴ ABuffers Ϊڴ
  if Assigned(Memory) then
    inherited Clear;
  FSetMode := True;
  FNewSize := ASize;
  SetPointer(ABuffer, ASize);  // ڴ
  Capacity := ASize;  // 룬 Free ʱͷڴ
  FSetMode := False;
  Position := 0;
end;

{ TIOCPDocument }

constructor TIOCPDocument.Create(const AFileName: String; CreateNew: Boolean);
begin
  inherited Create(0);
  if (AFileName = '') then  // ʱļرʱɾ
  begin
    FTempFile := True;
    InternalCreate(iocp_varis.gTempPath + '_' +
                   IntToStr(NativeUInt(Self)) + '.tmp', True);
  end else
  begin  // »ļ
    FTempFile := False;
    InternalCreate(AFileName, CreateNew);
  end;
end;

constructor TIOCPDocument.CreateEx(const AFileName: String);
begin
  inherited Create(0);
  // ֻļ
  FHandle := InternalOpenFile(AFileName, True);  // ֻ
  if (FHandle > 0) then
  begin
    FFileName := AFileName;
    FOriginSize := GetFileSize64(FHandle);  // ԭʼ
    GetFileTime(FHandle, @FCreationTime, @FAccessTime, @FLastWriteTime);
  end else
  begin
    iocp_log.WriteLog('TIOCPDocument.CreateEx->ļ쳣' + AFileName);
    Raise Exception.Create('ļ쳣.');
  end;
end;

destructor TIOCPDocument.Destroy;
begin
  Self.Close(FTempFile);
  inherited;
end;

procedure TIOCPDocument.InternalCreate(const AFileName: String; CreateNew: Boolean);
begin
  // InternalOpenFile  INVALID_HANDLE_VALUE תΪ 0
  if CreateNew then  // ½ļ
    FHandle := FileCreate(AFileName, fmCreate or fmOpenWrite or fmShareDenyWrite)
  else begin  // ļ
    FHandle := InternalOpenFile(AFileName, False); // д
    FOriginSize := GetFileSize64(FHandle);  // ԭʼ
    GetFileTime(FHandle, @FCreationTime, @FAccessTime, @FLastWriteTime);
  end;
  if (FHandle > 0) then
    FFileName := AFileName
  else begin
    iocp_log.WriteLog('TIOCPDocument.InternalCreate->½/ļ쳣' + AFileName);
    Raise Exception.Create('½/ļ쳣.');
  end;
end;

procedure TIOCPDocument.Close(DeleFile: Boolean);
begin
  if (FHandle > 0) then
  begin
    try
      CloseHandle(FHandle);
    finally
      FHandle := 0;
    end;
    if DeleFile or FTempFile then  // ɾʱļ
      {$IFDEF DELPHI_XE7UP}System.{$ENDIF}SysUtils.DeleteFile(FFileName);
  end;
end;

procedure TIOCPDocument.SetFileInf(Params: TReceivePack);
begin
  // ѽļļ
  //   TBaseMessage.GetFileInfo

  // ϵʱ AttachSize ǿ鳤
  FOriginSize := Params.GetFileSize;
  Size := FOriginSize;
  Position := 0;  // 

  if (FTempFile = False) then  // ʱļ
  begin
    FCreationTime.dwLowDateTime := Params.AsCardinal['_creationLow'];
    FCreationTime.dwHighDateTime := Params.AsCardinal['_creationHigh'];
    FAccessTime.dwLowDateTime := Params.AsCardinal['_accessLow'];
    FAccessTime.dwHighDateTime := Params.AsCardinal['_accessHigh'];
    FLastWriteTime.dwLowDateTime := Params.AsCardinal['_modifyLow'];
    FLastWriteTime.dwHighDateTime := Params.AsCardinal['_modifyHigh'];

    SetFileTime(FHandle, @FCreationTime, @FAccessTime, @FLastWriteTime);
  end;
end;

procedure TIOCPDocument.RenameDoc(var AFileName: String);
var
  i: Integer;
begin
  Close;
  if RenameFile(FFileName, AFileName) then
    FFileName := AFileName
  else begin
    i := Pos('_UNZIP', FFileName);  // ѽѹԭļ
    if (i = 0) then
      i := Pos('.chunk', FFileName);  // ļ
    if (i > 0) and RenameFile(FFileName, Copy(FFileName, 1, i - 1)) then
    begin
      Delete(FFileName, i, 6); // ׺Ϊ 6 ֽ
      AFileName := FFileName;
    end;
  end;
end;

{ TVarField }

constructor TVarField.Create(AName: AnsiString);
begin
  inherited Create;
  FName := AName;
  FData.EleType := etNull;
end;

destructor TVarField.Destroy;
begin
  InterClear;
  inherited;
end;

function TVarField.FieldSpace: Integer;
begin
  // ȡ洢ռС
  Result := GetSize;
  Inc(Result, STREAM_VAR_SIZE + Length(FName));
  if (FData.EleType in [etStream, etBuffer, etString, etRecord]) then
    Inc(Result, SizeOf(Integer));
end;

function TVarField.GetAsBoolean: Boolean;
  function CompareStr(const S: AnsiString): Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
  begin
    // True -> 1, SetAsBoolean
    Result := (S = '1') or (S = 'True') or (S = 'Yes');
  end;
begin
  case FData.EleType of
    etBoolean:
      Result := FData.BooleanValue;
    etString:
      Result := CompareStr(AsString);
    etCardinal:
      Result := FData.CardinalValue > 0;
    etFloat:
      Result := FData.FloatValue > 0;
    etInt64:
      Result := FData.Int64Value > 0;
    etInteger:
      Result := FData.IntegerValue > 0;
    else
      Result := False;
  end;
end;

function TVarField.GetAsBuffer: TMemBuffer;
begin
  // ʱãһݣⲿҪͷ Result
  if (FData.EleType = etBuffer) then
  begin
    Result := GetBuffer(FData.DataSize);
    System.Move(FData.Data^, Result^, FData.DataSize);
  end else
    Result := nil;
end;

function TVarField.GetAsCardinal: Cardinal;
begin
  if (FData.EleType = etString) then
    Result := StrToInt(AsString)
  else
    Result := FData.CardinalValue;
end;

function TVarField.GetAsDateTime: TDateTime;
begin
  if (FData.EleType = etString) then
    Result := StrToDateTime(AsString)
  else
    Result := FData.DateTimeValue;
end;

function TVarField.GetAsFloat: Double;
begin
  if (FData.EleType = etString) then
    Result := StrToFloat(AsString)
  else
    Result := FData.FloatValue;
end;

function TVarField.GetAsInt64: Int64;
begin
  case FData.EleType of
    etInt64:
      Result := FData.Int64Value;
    etCardinal:
      Result := FData.CardinalValue;
    etInteger:
      Result := FData.IntegerValue;
    etString:
      Result := StrToInt64(AsString);
    else
      Result := 0;
  end;
end;

function TVarField.GetAsInteger: Integer;
begin
  if (FData.EleType = etString) then
    Result := StrToInt(AsString)
  else
    Result := FData.IntegerValue;
end;

function TVarField.GetAsObject: TObject;
begin
  case FData.EleType of
    etCardinal:
      Result := TObject(GetAsCardinal);
    etInteger:
      Result := TObject(GetAsInteger);
    etInt64:
      Result := TObject(GetAsInt64);
    else
      Result := nil;
  end;
end;

function TVarField.GetAsRecord: TBasePack;
begin
  // һݣⲿҪͷ ResultʱΪ TMemoryStream ã
  if (FData.EleType = etRecord) then
  begin
    Result := TCustomPack.Create;  //  TCustomPackⲿʹ
    Result.ScanBuffers(TMemoryStream(FData.Data).Memory, FData.DataSize); // 
  end else
    Result := nil;
end;

function TVarField.GetAsStream: TStream;
begin
  // һݣⲿҪͷ ResultʱΪ TStream ã
  case FData.EleType of
    etRecord,
    etStream: begin // ʱã
      Result := TMemoryStream.Create;
      TStream(FData.Data).Position := 0;  // 
      Result.CopyFrom(TStream(FData.Data), FData.DataSize);
      Result.Position := 0;
    end;
    etBuffer,
    etString: begin // תΪ
      Result := TMemoryStream.Create;
      Result.Size := FData.DataSize;
      Result.Write(FData.Data^, FData.DataSize);
    end;
    else
      Result := Nil;
  end;
end;

function TVarField.GetAsString: AnsiString;
const
  BOOLEAN_STRS: array[Boolean] of AnsiString = ('0', '1');
begin
  //  String ת
  case FData.EleType of
    etBuffer,
    etString:
      SetString(Result, PAnsiChar(FData.Data), FData.DataSize);
    etRecord,
    etStream:
      if (TStream(FData.Data) is TMemoryStream) then
        SetString(Result, PAnsiChar(TMemoryStream(FData.Data).Memory), FData.DataSize)
      else begin
        SetLength(Result, FData.DataSize);
        TStream(FData.Data).Read(Result[1], FData.DataSize);
      end;
    etBoolean:
      Result := BOOLEAN_STRS[FData.BooleanValue];
    etCardinal:
      Result := IntToStr(FData.CardinalValue);
    etDateTime:
      Result := DateTimeToStr(FData.DateTimeValue);
    etFloat:
      Result := FloatToStr(FData.FloatValue);
    etInt64:
      Result := IntToStr(FData.Int64Value);
    etInteger:
      Result := IntToStr(FData.IntegerValue);
    else
      Result := '';
  end;
end;

function TVarField.GetAsVariant: Variant;
begin
  // ʱΪ StreamתΪ Variant
  if (FData.DataSize = 0) or (FData.Data = nil) then
    Result := Null
  else  // תΪ varByte Variant ͣѹݼ Delta
  if (FData.EleType in [etRecord, etStream]) then
    Result := iocp_utils.StreamToVariant(TMemoryStream(FData.Data), True)
  else
    Result := iocp_utils.StreamToVariant(GetAsStream as TMemoryStream, True);
end;

function TVarField.GetDataRef: Pointer;
begin
  Result := FData.Data;  // 䳤õַ
end;

function TVarField.GetIsNull: Boolean;
begin
  Result := (FData.EleType = etNull) or
            (FData.EleType >= etBuffer) and (FData.DataSize = 0);
end;

function TVarField.GetSize: Integer;
begin
  case FData.EleType of
    etBoolean:
      Result := SizeOf(Boolean);
    etDateTime:
      Result := SizeOf(TDateTime);
    etCardinal:
      Result := SizeOf(Cardinal);
    etFloat:
      Result := SizeOf(Double);
    etInt64:
      Result := SizeOf(Int64);
    etInteger:
      Result := SizeOf(Integer);
    etBuffer, etString,
    etRecord, etStream:
      Result := FData.DataSize;
    else  // etNull
      Result := 0;
  end;
end;

procedure TVarField.InterClear;
begin
  // ռͷŶҲظֵ
  case FData.EleType of
    etBuffer:
      if Assigned(FData.Data) then
      begin
        FreeBuffer(FData.Data);
        FData.Data := nil;
      end;
    etString:
      if Assigned(FData.Data) then
      begin
        FreeMem(FData.Data);
        FData.Data := nil;
      end;
    etRecord, etStream:
      if Assigned(FData.Data) then
      begin
        TStream(FData.Data).Free;
        FData.Data := nil;
      end;
  end;
end;

procedure TVarField.InterSetBuffer(AEleType: TElementType; ABuffer: PAnsiChar; ASize: Integer);
begin
  // ʱڴȡֶ
  if (ASize > 0) then
  begin
    FData.EleType := AEleType;
    FData.DataSize := ASize;
    if (AEleType = etBuffer) then
      FData.Data := GetBuffer(ASize)
    else
      GetMem(FData.Data, ASize);
    System.Move(ABuffer^, FData.Data^, ASize);
  end else
  begin
    FData.EleType := etNull;
    FData.DataSize := 0;
    FData.Data := nil;    
  end;
end;

procedure TVarField.InterSetStream(AEleType: TElementType; ABuffer: PAnsiChar; ASize: Integer);
begin
  // ʱڴȡڴ
  if (ASize > 0) then
  begin
    FData.EleType := AEleType;
    FData.DataSize := ASize;
    FData.Data := TMemoryStream.Create;
    TMemoryStream(FData.Data).Size := ASize;
    System.Move(ABuffer^, TMemoryStream(FData.Data).Memory^, ASize);
  end else
  begin
    FData.EleType := etNull;
    FData.DataSize := 0;
    FData.Data := nil;    
  end;
end;

procedure TVarField.SetAsBoolean(const Value: Boolean);
begin
  FData.EleType := etBoolean;
  FData.BooleanValue := Value;
end;

procedure TVarField.SetAsBuffer(const Value: TMemBuffer);
begin
  //  TMemBuffer ã߲ͷ Value
  if Assigned(Value) then
  begin
    FData.EleType := etBuffer;
    FData.DataSize := BufferSize(Value);
    FData.Data := Value;
  end else
  begin
    FData.EleType := etNull;  // ֵ
    FData.DataSize := 0;
    FData.Data := nil;
  end;
end;

procedure TVarField.SetAsCardinal(const Value: Cardinal);
begin
  FData.EleType := etCardinal;
  FData.CardinalValue := Value;
end;

procedure TVarField.SetAsDateTime(const Value: TDateTime);
begin
  FData.EleType := etDateTime;
  FData.DateTimeValue := Value;
end;

procedure TVarField.SetAsFloat(const Value: Double);
begin
  FData.EleType := etFloat;
  FData.FloatValue := Value;
end;

procedure TVarField.SetAsInt64(const Value: Int64);
begin
  FData.EleType := etInt64;
  FData.Int64Value := Value;
end;

procedure TVarField.SetAsInteger(const Value: Integer);
begin
  FData.EleType := etInteger;
  FData.IntegerValue := Value;
end;

procedure TVarField.SetAsRecord(const Value: TBasePack);
var
  Stream: TMemoryStream;
begin
  // ¼, ⲿҪͷ Value
  if Assigned(Value) then
  begin
    Stream := TMemoryStream.Create;
    Value.SaveToStream(Stream, False);
    FData.EleType := etRecord;
    FData.DataSize := Stream.Size;  // 2018-09-09
    FData.Data := Stream;
  end else
  begin
    FData.EleType := etNull;
    FData.DataSize := 0;
    FData.Data := nil;
  end;
end;

procedure TVarField.SetAsStream(const Value: TStream);
begin
  // , ⲿͷ Value
  if Assigned(Value) then
  begin
    FData.EleType := etStream;
    FData.DataSize := Value.Size;
    FData.Data := Value;
  end else
  begin
    FData.EleType := etNull;
    FData.DataSize := 0;
    FData.Data := nil;
  end;
end;

procedure TVarField.SetAsString(const Value: AnsiString);
begin
  // ַ
  InterSetBuffer(etString, @Value[1], Length(Value));
end;

{ TBasePack }

procedure TBasePack.CheckFieldName(const Value: AnsiString);
begin
  if not (Length(Value) in [1..128]) then
    raise Exception.Create('ƲΪջ̫.');
end;

procedure TBasePack.CheckStringValue(const Value: AnsiString);
begin
  // JSON ż
end;

procedure TBasePack.Clear;
var
  i: Integer;
begin
  FSize := 0;
  for i := 0 to FList.Count - 1 do
    TVarField(FList.PopFirst).Free;
end;

constructor TBasePack.Create;
begin
  inherited;
  FList := TInList.Create;
end;

destructor TBasePack.Destroy;
begin
  Clear;
  FList.Free;
  inherited;
end;

function TBasePack.FindField(VarName: AnsiString; var Field: TVarField): Boolean;
var
  i: Integer;
begin
  // ұ/ֶ
  //  VarName  AnsiStringд
  VarName := UpperCase(VarName);
  for i := 0 to FList.Count - 1 do
  begin
    Field := TVarField(FList.Items[i]);
    if (Field.FName = VarName) then  // ͬΪ AnsiString
    begin
      Result := True;
      Exit;
    end;
  end;
  Field := nil;
  Result := False;
end;

function TBasePack.GetAsBoolean(const Index: String): Boolean;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsBoolean
  else
    Result := False;
end;

function TBasePack.GetAsBuffer(const Index: String): TMemBuffer;
var
  Field: TVarField;
begin
  // һݣⲿҪͷ Resultʱã
  if FindField(Index, Field) then
    Result := Field.AsBuffer
  else
    Result := nil;
end;

function TBasePack.GetAsCardinal(const Index: String): Cardinal;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsCardinal
  else
    Result := 0;
end;

function TBasePack.GetAsDateTime(const Index: String): TDateTime;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsDateTime
  else
    Result := 0.0;
end;

function TBasePack.GetAsDocument(const Index: String): String;
begin
  Raise Exception.Create(' Document[] ȡļ');
end;

function TBasePack.GetAsFloat(const Index: String): Double;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsFloat
  else
    Result := 0.0;
end;

function TBasePack.GetAsInt64(const Index: String): Int64;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsInt64
  else
    Result := 0;
end;

function TBasePack.GetAsInteger(const Index: String): Integer;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsInteger
  else
    Result := 0;
end;

function TBasePack.GetAsRecord(const Index: String): TBasePack;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsRecord
  else
    Result := nil;
end;            

function TBasePack.GetAsStream(const Index: String): TStream;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsStream
  else
    Result := nil;
end;

function TBasePack.GetAsString(const Index: String): String;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsString
  else
    Result := '';
end;

function TBasePack.GetAsVariant(const Index: String): Variant;
var
  Field: TVarField;
begin
  if FindField(Index, Field) then
    Result := Field.AsVariant
  else
    Result := Null;
end;

function TBasePack.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TBasePack.GetFields(Index: Integer): TVarField;
begin
  // ȡֶ
  Result := TVarField(FList.Items[Index]);
end;

function TBasePack.GetSize: Cardinal;
begin
  // ȡܳ
  Result := FSize;
end;

procedure TBasePack.SaveToFile(const AFileName: String);
var
  Stream: TFileStream;
begin
  // ļ
  Stream := TFileStream.Create(AFileName, fmCreate);
  try
    if (Stream.Handle > 0) then
      SaveToStream(Stream);
  finally
    Stream.Free;
  end;
end;

procedure TBasePack.SaveToMemStream(Stream: TMemoryStream);
begin
  // дֶݵڴ
  if (Stream.Size <> FSize) then  // Ԥ賤
    Stream.Size := FSize;
  WriteBuffers(Stream.Memory); // дڴ
end;

procedure TBasePack.SaveToStream(Stream: TStream; DelParams: Boolean);
var
  mStream: TMemoryStream;
begin
  // ת/ʽ
  if Assigned(Stream) and (FSize > 0) then
    try
      if (Stream is TMemoryStream) then  // ڴ
        SaveToMemStream(TMemoryStream(Stream))
      else begin
        // תڴ
        Stream.Position := 0;
        mStream := TMemoryStream.Create;
        try
          SaveToMemStream(mStream);
          Stream.Write(mStream.Memory^, mStream.Size);
        finally
          mStream.Free;
        end;
      end;
    finally
      Stream.Position := 0;
      if DelParams then  // 
        Clear;
    end;
end;

procedure TBasePack.ScanBuffers(ABuffer: PAnsiChar; ASize: Cardinal);
var
  i, iCount: Integer;
  Field: TVarField;
  VarName: AnsiString;
  Source: PListVariable;
begin                              
  // ڴб
  //   ʽElementCount + Variable, Variable2...
  // Variable ʽEleType + NameSize + Name + Value | BufferSize + Buffer

  // ܳ
  FSize := ASize;

  // 
  iCount := PInteger(ABuffer)^;
  Inc(ABuffer, SizeOf(Integer));

  for i := 0 to iCount - 1 do
  begin
    // ܴ쳣 NameSize ̫ -> ڴ治
    Source := PListVariable(ABuffer);
    if (Source^.NameSize > 128) then
    begin
      FError := True;
      Break;
    end;

    // ȡ: VarName
    Inc(ABuffer, STREAM_VAR_SIZE);

    SetLength(VarName, Source^.NameSize);
    System.Move(ABuffer^, VarName[1], Source^.NameSize);

    // ӱĬΪ etNull
    Field := TVarField.Create(VarName);
    FList.Add(Field); // inherited Add(Field);

    // ֵλ
    Inc(ABuffer, Source^.NameSize);
    
    // ֵ򳤶: Value | BufferSize
    case Source^.EleType of
      etBoolean: begin   // ߼
        Field.SetAsBoolean(PBoolean(ABuffer)^);
        Inc(ABuffer, SizeOf(Boolean));
      end;
      etInteger: begin   // 
        Field.SetAsInteger(PInteger(ABuffer)^);
        Inc(ABuffer, SizeOf(Integer));
      end;
      etCardinal: begin  // ޷
        Field.SetAsCardinal(PCardinal(ABuffer)^);
        Inc(ABuffer, SizeOf(Cardinal));
      end;
      etFloat: begin     // 
        Field.SetAsFloat(PDouble(ABuffer)^);
        Inc(ABuffer, SizeOf(Double));
      end;
      etInt64: begin     // 64 λ
        Field.SetAsInt64(PInt64(ABuffer)^);
        Inc(ABuffer, SizeOf(Int64));
      end;
      etDateTime: begin  // ʱ
        Field.SetAsDateTime(PDateTime(ABuffer)^);
        Inc(ABuffer, SizeOf(TDateTime));
      end;

      etBuffer,          // Զڴ
      etString: begin    // ַ
        Field.InterSetBuffer(Source^.EleType, ABuffer + SizeOf(Integer),
                             PInteger(ABuffer)^);
        Inc(ABuffer, SizeOf(Integer) + PInteger(ABuffer)^);
      end;

      etRecord,          // ¼
      etStream: begin    // 
        Field.InterSetStream(Source^.EleType, ABuffer + SizeOf(Integer),
                             PInteger(ABuffer)^);
        Inc(ABuffer, SizeOf(Integer) + PInteger(ABuffer)^);      
      end;
    end;
  end;
end;

procedure TBasePack.SetAsBoolean(const Index: String; const Value: Boolean);
var
  Variable: TListVariable;
begin
  Variable.BooleanValue := Value;
  SetField(etBoolean, Index, @Variable);
end;

procedure TBasePack.SetAsBuffer(const Index: String; const Value: TMemBuffer);
var
  Variable: TListVariable;
begin
  Variable.Data := Value;
  SetField(etBuffer, Index, @Variable);
end;

procedure TBasePack.SetAsCardinal(const Index: String; const Value: Cardinal);
var
  Variable: TListVariable;
begin
  Variable.CardinalValue := Value;
  SetField(etCardinal, Index, @Variable);
end;

procedure TBasePack.SetAsDateTime(const Index: String; const Value: TDateTime);
var
  Variable: TListVariable;
begin
  Variable.DateTimeValue := Value;
  SetField(etDateTime, Index, @Variable);
end;

procedure TBasePack.SetAsDocument(const Index, Value: String);
var
  Stream: TFileStream;
  Variable: TListVariable;
begin
  // 򿪡һļļ̫󣩣 Document[] ȡļ
  FError := True;
  if FileExists(Value) then
  begin
    // TFileStream.Handle ߰汾Ϊ THandle 
    Stream := TFileStream.Create(Value, fmOpenRead or fmShareDenyWrite);
    if (Stream.Handle <= 0) or (Stream.Size = 0) then
    begin
      Stream.Free;
      FError := False;
      Variable.Data := nil;
      SetField(etStream, Index, @Variable);
    end else
    begin
      FError := False;
      Variable.Data := Stream;
      SetField(etStream, Index, @Variable);
    end;
  end;
end;

procedure TBasePack.SetAsFloat(const Index: String; const Value: Double);
var
  Variable: TListVariable;
begin
  Variable.FloatValue := Value;
  SetField(etFloat, Index, @Variable);
end;

procedure TBasePack.SetAsInt64(const Index: String; const Value: Int64);
var
  Variable: TListVariable;
begin
  Variable.Int64Value := Value;
  SetField(etInt64, Index, @Variable);
end;

procedure TBasePack.SetAsInteger(const Index: String; const Value: Integer);
var
  Variable: TListVariable;
begin
  Variable.IntegerValue := Value;
  SetField(etInteger, Index, @Variable);
end;

procedure TBasePack.SetAsRecord(const Index: String; const Value: TBasePack);
var
  Variable: TListVariable;
begin
  Variable.Data := Value;
  SetField(etRecord, Index, @Variable);
end;

procedure TBasePack.SetAsStream(const Index: String; const Value: TStream);
var
  Variable: TListVariable;
begin
  Variable.Data := Value;
  SetField(etStream, Index, @Variable);
end;

procedure TBasePack.SetAsString(const Index, Value: String);
begin
  SetField(etString, Index, nil, Value);
end;

procedure TBasePack.SetAsVariant(const Index: String; const Value: Variant);
begin
  // ñͱValue ʺϴݣ
  SetAsStream(Index, iocp_utils.VariantToStream(Value, True));
end;

procedure TBasePack.SetField(EleType: TElementType; const VarName: AnsiString;
                             const Value: PListVariable; const SValue: AnsiString = '');
var
  Field: TVarField;
begin
  // 

  // etBufferetStreametRecord ֱ䳤ͣ
  // ֻãSaveToMemStream ʱ룬Clear ʱͷš

  // ƺϷ
  CheckFieldName(VarName);

  if (EleType = etString) then  // JSON ݺϷ
    CheckStringValue(SValue);

  // Ƿ
  if FindField(VarName, Field) then
  begin
    Dec(FSize, Field.FieldSpace); // -+
    Field.InterClear;  // ܸıͣͷſռ
  end else begin  // һ
    Field := TVarField.Create(UpperCase(VarName));
    FList.Add(Field);
  end;

  case EleType of
    etBoolean:  // ߼
      Field.SetAsBoolean(Value^.BooleanValue);
    etCardinal: // ޷
      Field.SetAsCardinal(Value^.CardinalValue);
    etDateTime: // ʱ 8 ֽ
      Field.SetAsDateTime(Value^.DateTimeValue);
    etFloat:    // 
      Field.SetAsFloat(Value^.FloatValue);
    etInt64:    // 64 λ
      Field.SetAsInt64(Value^.Int64Value);
    etInteger:  // 
      Field.SetAsInteger(Value^.IntegerValue);
    etBuffer:   // ڴ
      Field.SetAsBuffer(Value^.Data);
    etString:   // ַ
      Field.SetAsString(SValue);  //  AnsiString
    etRecord:   // ¼
      Field.SetAsRecord(Value^.Data);
    etStream:   // 
      Field.SetAsStream(Value^.Data);
  end;

  // תܳ = FSize
  //     ʽElementCount + Variable, Variable2...
  // ʽEleType + NameSize + Name + Value | (BufferSize + Buffer)
  //   TBasePack.SaveToMemStream

  // ռ
  if (FSize = 0) then
    Inc(FSize, SizeOf(Integer));

  // EleType + NameSize + Ƴ
  Inc(FSize, STREAM_VAR_SIZE + Length(VarName));

  // ݳ
  Inc(FSize, Field.Size);

  // 䳤͵ĳ
  if (EleType in [etStream, etBuffer, etString, etRecord]) then
    Inc(FSize, SizeOf(Integer));

end;

procedure TBasePack.VarToJSON(var Buf: PAnsiChar; const VarName,
  VarValue: AnsiString; Digital: Boolean; FirstPos, EndPos: Boolean);
begin
  // ֶαΪ JSON
  if FirstPos then  // ʼ
  begin
    PDblChars(Buf)^ := AnsiString('{"');
    Inc(Buf, 2);
  end else
  begin
    PAnsiChar(Buf)^ := AnsiChar('"');
    Inc(Buf);
  end;

  // 
  System.Move(VarName[1], Buf^, Length(VarName));
  Inc(Buf, Length(VarName));

  // ð
  if Digital then  // 
  begin
    PDblChars(Buf)^ := AnsiString('":');
    Inc(Buf, 2)
  end else
  begin
    PThrChars(Buf)^ := AnsiString('":"');
    Inc(Buf, 3);
  end;

  // ֵ
  if (Length(VarValue) > 0) then
  begin
    System.Move(VarValue[1], Buf^, Length(VarValue));
    Inc(Buf, Length(VarValue));
  end;

  if EndPos then  // ĩβ
  begin
    if Digital then  // ֻ }
    begin
      PAnsiChar(Buf)^ := AnsiChar('}');
      Inc(Buf);
    end else
    begin
      PDblChars(Buf)^ := AnsiString('"}');
      Inc(Buf, 2);
    end;
  end else
  begin
    if Digital then  // 
    begin
      PAnsiChar(Buf)^ := AnsiChar(',');
      Inc(Buf);
    end else
    begin
      PDblChars(Buf)^ := AnsiString('",');
      Inc(Buf, 2);
    end;
  end;
end;

procedure TBasePack.WriteBuffers(const Buf: Pointer);
var
  i: Integer;
  p: PAnsiChar;
  Field: TVarField;
  Target: PListVariable;
begin
  // ת/ʽڴ
  //   ʽElementCount + Variable, Variable2...
  // ʽEleType + NameSize + Name + Value | (BufferSize + Buffer)

  // Ԫظ
  p := PAnsiChar(Buf);

  PInteger(p)^ := FList.Count;  // 
  Inc(p, SizeOf(Integer));

  for i := 0 to FList.Count - 1 do
  begin
    // ֶ
    Field := TVarField(FList.Items[i]);
    Target := PListVariable(p);

    // ͡ƳȣEleType + NameSize
    Target^.EleType := Field.FData.EleType;
    Target^.NameSize := Length(Field.FName);
    Inc(p, STREAM_VAR_SIZE);

    // ƣName: AnsiString
    System.Move(Field.FName[1], p^, Target^.NameSize);
    Inc(p, Target^.NameSize);

    // ֵݳȣ Value | BufferSize
    case Field.FData.EleType of
      etNull:            // ֵ
        { Empty } ;
      etBoolean: begin   // ߼
        PBoolean(p)^ := Field.FData.BooleanValue;
        Inc(p, SizeOf(Boolean));
      end;
      etInteger: begin   // 
        PInteger(p)^ := Field.FData.IntegerValue;
        Inc(p, SizeOf(Integer));
      end;
      etCardinal: begin  // ޷
        PCardinal(p)^ := Field.FData.CardinalValue;
        Inc(p, SizeOf(Cardinal));
      end;
      etFloat: begin     // 
        PDouble(p)^ := Field.FData.FloatValue;
        Inc(p, SizeOf(Double));
      end;
      etInt64: begin     // 64 λ
        PInt64(p)^ := Field.FData.Int64Value;
        Inc(p, SizeOf(Int64));
      end;
      etDateTime: begin  // ʱ
        PDateTime(p)^ := Field.FData.DateTimeValue;
        Inc(p, SizeOf(TDateTime));
      end;

      // 䳤: BufferSize + Buffer

      etBuffer,         // Զڴ
      etString: begin   // ַ
        PInteger(p)^ := Field.FData.DataSize;
        Inc(p, SizeOf(Integer));
        if (Field.FData.DataSize > 0) then
        begin
          System.Move(Field.FData.Data^, p^, Field.FData.DataSize);
          Inc(p, Field.FData.DataSize);
        end;
      end;

      etStream,         // 
      etRecord: begin   // ¼
        PInteger(p)^ := Field.FData.DataSize;
        Inc(p, SizeOf(Integer));
        if (Field.FData.DataSize > 0) then
        begin
          TStream(Field.FData.Data).Position := 0;  // ʼλ
          TStream(Field.FData.Data).Read(p^, Field.FData.DataSize);
          Inc(p, Field.FData.DataSize);
        end;
      end;
    end;
  end;
end;

procedure TBasePack.Initialize(Stream: TStream; ClearIt: Boolean);
var
  mStream: TMemoryStream;
begin
  // 롢ϢҪⲿͷ
  if Assigned(Stream) then
    try
      if (FSize > 0) then
        Clear;
      FError := False;
      if (Stream is TMemoryStream) then  // ڴ
        with TMemoryStream(Stream) do
          try
            ScanBuffers(Memory, Size);
          finally
            if ClearIt then
              Clear;  // 
          end
      else begin
        Stream.Position := 0;
        mStream := TMemoryStream.Create; // ʱ
        mStream.LoadFromStream(Stream);
        try
          ScanBuffers(mStream.Memory, mStream.Size);
        finally
          mStream.Free;
        end;
      end;
    except
      on E: Exception do
      begin
        FError := True;  // 쳣
        iocp_log.WriteLog('TBasePack.Initialize->' + E.Message);
      end;
    end;
end;

procedure TBasePack.Initialize(const AFileName: String);
var
  Handle: THandle;
  FileSize, NoUsed: Cardinal;
  Stream: TMemoryStream;
begin
  // ļ롢Ϣļ̫
  if FileExists(AFileName) then
  begin
    if (FSize > 0) then
      Clear;

    FError := False;
    Handle := InternalOpenFile(AFileName);
    FileSize := GetFileSize(Handle, nil); // ִ֧ļ

    Stream := TMemoryStream.Create;
    Stream.Size := FileSize;

    try
      try
        // 뵽ڴ
        ReadFile(Handle, Stream.Memory^, FileSize, NoUsed, nil);
        ScanBuffers(Stream.Memory, FileSize);
      finally
        CloseHandle(Handle);
        Stream.Free;
      end;
    except
      on E: Exception do
      begin
        FError := True;  // 쳣
        iocp_log.WriteLog('TBasePack.Initialize->' + E.Message);
      end;
    end;
  end;
end;

{ THeaderPack }

function THeaderPack.GetAttachFileName: String;
begin
  // ļȫ·
  Result := AsString['_AttachFileName'];
end;

function THeaderPack.GetConnection: Integer;
begin
  // ӱ
  Result := AsInteger['_Connection'];
end;

function THeaderPack.GetDateTime: TDateTime;
begin
  // Ϣʱ
  Result := AsDateTime['_DateTime'];
end;

function THeaderPack.GetDirectory: String;
begin
  // ·
  Result := AsString['_Directory'];
end;

function THeaderPack.GetFileName: String;
begin
  // ļ
  Result := AsString['_FileName'];
end;

function THeaderPack.GetFileSize: TFileSize;
begin
  // ȡļС
  Result := AsInt64['_FileSize'];
end;

function THeaderPack.GetFunctionGroup: string;
begin
  // Զ̺
  Result := AsString['_FunctionGroup'];
end;

function THeaderPack.GetFunctionIndex: Integer;
begin
  // Զ̺
  Result := AsInteger['_FunctionIndex'];
end;

function THeaderPack.GetHasParams: Boolean;
begin
  // SQL Ƿ
  Result := AsBoolean['_HasParams'];
end;

procedure THeaderPack.GetHeadMsg(Msg: PMsgHead);
begin
  // ʱϢͷݵ Msg
  Msg^.Owner := FOwner;
  Msg^.SessionId := FSessionId;

  Msg^.MsgId := FMsgId;
  Msg^.DataSize := FDataSize;  // FSize
  Msg^.AttachSize := FAttachSize;
  Msg^.Offset := FOffset;
  Msg^.OffsetEnd := FOffsetEnd;

  Msg^.CheckType := FCheckType;
  Msg^.VarCount := FVarCount;
  Msg^.ZipLevel := FZipLevel;

  Msg^.Target := FTarget;
  Msg^.Action := FAction;
  Msg^.ActResult := FActResult;
end;

function THeaderPack.GetLocalPath: string;
begin
  // ļ·
  Result := AsString['_LocalPath'];
end;

function THeaderPack.GetMsg: String;
begin
  // Ϣ
  Result := AsString['_Msg'];
end;

function THeaderPack.GetMsgSize(RecvMode: Boolean): TFileSize;
  function GetEntitySize: TFileSize;
  begin
    if RecvMode then  // ģʽ
      Result := IOCP_SOCKET_SIZE + FDataSize
    else
      Result := IOCP_SOCKET_SIZE + FSize;
  end;
begin
  // ȡϢݵĳ
  if (FAction in FILE_CHUNK_ACTIONS) then
    Result := GetEntitySize + GetFileSize
  else
    Result := GetEntitySize + FAttachSize;
  case FCheckType of
    ctMurmurHash: begin
      if (FDataSize > 0) then
        Inc(Result, HASH_CODE_SIZE);
      if (FAttachSize > 0) then
        Inc(Result, HASH_CODE_SIZE);
    end;
    ctMD5: begin
      if (FDataSize > 0) then
        Inc(Result, HASH_CODE_SIZE * 2);
      if (FAttachSize > 0) then
        Inc(Result, HASH_CODE_SIZE * 2);
    end;
  end;
end;

function THeaderPack.GetNewFileName: String;
begin
  // µļ
  Result := AsString['_NewFileName'];
end;

function THeaderPack.GetPassword: String;
begin
  // /
  Result := AsString['_Password'];
end;

function THeaderPack.GetPeerIPPort: String;
begin
  // Ӧͻ˵ IP:Port
  Result := AsString['_Peer_IPPort'];
end;

function THeaderPack.GetReuseSessionId: Boolean;
begin
  // Ƿƾ֤
  Result := AsBoolean['_ReuseSessionId'];
end;

function THeaderPack.GetRole: TClientRole;
begin
  // ɫ/Ȩ
  Result := TClientRole(AsInteger['_Role']);
end;

function THeaderPack.GetSize: Cardinal;
begin
  // ȫĿռСǻࣩ
  if (FList.Count > 0) then
    Result := FSize
  else
    Result := FDataSize;
end;

function THeaderPack.GetSQL: String;
begin
  // SQL ı
  Result := AsString['_SQLText'];
end;

function THeaderPack.GetSQLName: String;
begin
  // SQL ƣԤ裬 iocp_sqlMgr.TInSQLManager
  Result := AsString['_SQLName'];
end;

function THeaderPack.GetStoredProcName: String;
begin
  // 洢
  Result := AsString['_StoredProcName'];
end;

function THeaderPack.GetToUser: String;
begin
  // Ŀû
  Result := AsString['_ToUser'];
end;

function THeaderPack.GetURL: String;
begin
  //  URL
  Result := AsString['_URL'];
end;

function THeaderPack.GetUserName: String;
begin
  // ûԴ
  Result := AsString['_UserName'];
end;

procedure THeaderPack.SetAttachFileName(const Value: String);
begin
  // Ԥ裺ļȫ·
  AsString['_AttachFileName'] := Value;
end;

procedure THeaderPack.SetConnection(const Value: Integer);
begin
  // Ԥ裺ݿӱ
  AsInteger['_Connection'] := Value;
end;

procedure THeaderPack.SetDateTime(const Value: TDateTime);
begin
  // Ԥ裺ʱ
  AsDateTime['_DateTime'] := Value;
end;

procedure THeaderPack.SetDirectory(const Value: String);
begin
  // Ԥ裺·
  AsString['_Directory'] := Value;
end;

procedure THeaderPack.SetFileName(const Value: String);
begin
  // Ԥ裺ļ
  AsString['_FileName'] := Value;
end;

procedure THeaderPack.SetFileSize(const Value: TFileSize);
begin
  // Ԥ裺ļС
  AsInt64['_FileSize'] := Value;
end;

procedure THeaderPack.SetFunctionGroup(const Value: String);
begin
  // Ԥ裺Զ̺
  AsString['_FunctionGroup'] := Value;
end;

procedure THeaderPack.SetFunctionIndex(const Value: Integer);
begin
  // Ԥ裺Զ̺Ŀ
  AsInteger['_FunctionIndex'] := Value;
end;

procedure THeaderPack.SetHasParams(const Value: Boolean);
begin
  // Ԥ裺SQL Ƿ
  AsBoolean['_HasParams'] := Value;
end;

procedure THeaderPack.SetHeadMsg(Msg: PMsgHead; ForReturn: Boolean);
begin
  // ʱ Msg ݵЭͷ
  FError := False;   // !!!
  FOwner := Msg^.Owner;
  FSessionId := Msg^.SessionId;
  FMsgId := Msg^.MsgId;

  if ForReturn then  // ˷
  begin
    FDataSize := 0;
    FAttachSize := 0;
    FVarCount := 0;
  end else
  begin
    FDataSize := Msg^.DataSize;
    FAttachSize := Msg^.AttachSize;
    FVarCount := Msg^.VarCount;
  end;

  FOffset := Msg^.Offset;
  FOffsetEnd := Msg^.OffsetEnd;

  FCheckType := Msg^.CheckType;
  FZipLevel := Msg^.ZipLevel;

  FTarget := Msg^.Target;
  FAction := Msg^.Action;
  FActResult := Msg^.ActResult;

  // ǷĲ
  if (FAction in ECHO_SVC_ACTIONS) then
    FAction := atUnknown;
end;

procedure THeaderPack.SetLocalPath(const Value: String);
begin
  // Ԥ裺ļ·
  AsString['_LocalPath'] := Value;
end;

procedure THeaderPack.SetMsg(const Value: String);
begin
  // Ԥ裺Ϣ
  AsString['_Msg'] := Value;
end;

procedure THeaderPack.SetNewFileName(const Value: String);
begin
  // Ԥ裺µļ
  AsString['_NewFileName'] := Value;
end;

procedure THeaderPack.SetPassword(const Value: String);
begin
  // Ԥ裺/
  AsString['_Password'] := Value;
end;

procedure THeaderPack.SetPeerIPPort(const Value: String);
begin
  // Ԥ裺Ӧͻ˵ IP:Port
  AsString['_Peer_IPPort'] := Value;
end;

procedure THeaderPack.SetReuseSessionId(const Value: Boolean);
begin
  // Ԥ裺Ƿƾ֤
  AsBoolean['_ReuseSessionId'] := Value;
end;

procedure THeaderPack.SetRole(const Value: TClientRole);
begin
  // Ԥ裺ɫ/Ȩ
  AsInteger['_Role'] := Integer(Value);
end;

procedure THeaderPack.SetSQL(const Value: String);
begin
  // Ԥ裺SQL ı
  AsString['_SQLText'] := Value;
  if (UpperCase(TrimLeft(Copy(Value, 1, 7))) = 'SELECT ') then
    FAction := atDBExecQuery
  else
    FAction := atDBExecSQL;
end;

procedure THeaderPack.SetSQLName(const Value: String);
begin
  // Ԥ裺SQL ƣԤ裬 iocp_sqlMgr.TInSQLManager
  AsString['_SQLName'] := Value;
end;

procedure THeaderPack.SetStoredProcName(const Value: String);
begin
  // Ԥ裺洢
  AsString['_StoredProcName'] := Value;
end;

procedure THeaderPack.SetToUser(const Value: String);
begin
  // Ԥ裺Ŀû = TargetUser
  AsString['_ToUser'] := Value;
end;

procedure THeaderPack.SetURL(const Value: String);
begin
  // Ԥ裺 URL
  AsString['_URL'] := Value;
end;

procedure THeaderPack.SetUserName(const Value: String);
begin
  // Ԥ裺ûԴ
  AsString['_UserName'] := Value;
end;

function THeaderPack.ToJSON: AnsiString;
const
  HEADER_SIZE = 150;  // Эͷ 150 ֽ
  BOOL_VALUES: array[Boolean] of string = ('False', 'True');
var
  p: PAnsiChar;
  k, i: Integer;
begin
  // ϢתΪ JSONЭͷ

  k := FList.Count;
  if (k = 0) then
    SetLength(Result, HEADER_SIZE)
  else begin
    if (FDataSize = 0) then
      SetLength(Result, HEADER_SIZE + Size + Size div 2)
    else
      SetLength(Result, HEADER_SIZE + FDataSize + FDataSize div 2);
  end;

  // ʼλ
  p := PAnsiChar(Result);

  // Ϣʽı䣬Эͷ⼸ֶûˣ
  // FDataSizeFAttachSizeFCheckTypeFZipLevel

  VarToJSON(p, 'Owner', IntToStr(FOwner), True, True);  // UInt64
  VarToJSON(p, 'SessionId', IntToStr(FSessionId), True);
  VarToJSON(p, 'MsgId', IntToStr(FMsgId), True);   // UInt64
  VarToJSON(p, 'VarCount', IntToStr(k + 7), True); // Count + Эͷֶ
  VarToJSON(p, 'Target', IntToStr(FTarget), True);
  VarToJSON(p, 'Action', IntToStr(Integer(FAction)), True);
  VarToJSON(p, 'ActResult', IntToStr(Integer(FActResult)), True, False, k = 0);

  if (k > 0) then
    for i := 0 to k - 1 do
      with Fields[i] do
        case VarType of
          etNull:
            VarToJSON(p, Name, 'Null', True, False, i = k - 1);
          etBoolean:
            VarToJSON(p, Name, BOOL_VALUES[AsBoolean], True, False, i = k - 1);          
          etCardinal..etInteger:
            VarToJSON(p, Name, AsString, True, False, i = k - 1);
          else
            VarToJSON(p, Name, AsString, False, False, i = k - 1);          
        end;
        
  Delete(Result, p - PAnsiChar(Result) + 1, Length(Result));

end;

procedure THeaderPack.ToRecord(var ABuffer: PAnsiChar; var ASize: Cardinal);
var
  Dest: PAnsiChar;
  Rec: PStreamVariable;
  ClearMem: Boolean;
begin
  // ѱתΪ TElementType.etRecord ¼
  //   ʽEleType + NameSize + TMsgHead + [Buffer]
  //   TMsgHead ں

  // ڴ
  ASize := STREAM_VAR_SIZE + MSG_HEAD_SIZE + FSize;
  GetMem(ABuffer, ASize);

  // ¼Ƴ=0ݳ=FSize
  Rec := PStreamVariable(ABuffer);
  Rec^.NameSize := 0;

  // Эͷ
  Dest := ABuffer;
  Inc(Dest, STREAM_VAR_SIZE);

  GetHeadMsg(PMsgHead(Dest));

  if (FList.Count = 0) or (FSize = 0) then  // ֵ
    Rec^.EleType := etNull
  else begin  // 
    Rec^.EleType := etRecord;
    ClearMem := Assigned(FMain.Memory) = False;

    if ClearMem then
      SaveToMemStream(FMain);  // תڴ

    //  Memory  ABuffer ĩβ
    Inc(Dest, MSG_HEAD_SIZE);
    System.Move(FMain.Memory^, Dest^, FSize);

    if ClearMem then  // ԭ״̬
      FMain.Clear;
  end;
end;

{ TReceivePack }

procedure TReceivePack.Cancel;
begin
  if Assigned(FAttachment) then  // ͷŸ
    FAttachment.Close(not (FAction in FILE_CHUNK_ACTIONS));
  Clear;
end;

procedure TReceivePack.Clear;
begin
  // TServerReceiver.OwnerClear
  FActResult := arUnknown; // ȡʱ
  if Assigned(FMain) then  // գͷ
    FMain.Clear;
  if Assigned(FAttachment) then  // ͷŸ
    FreeAndNil(FAttachment);
  inherited;
end;

constructor TReceivePack.Create;
begin
  inherited;
  FMain := TInMemStream.Create;  // 
end;

procedure TReceivePack.CreateAttachment(const ALocalPath: String);
var
  NewCreated: Boolean;
  LocalFileName: String;
begin
  // ļļٸѹ

  FError := True;

  try
    // ·+ļ
    LocalFileName := ALocalPath + GetFileName;

    if (FileExists(LocalFileName) = False) then
      NewCreated := True
    else begin
      NewCreated := (FAction in FILE_CHUNK_ACTIONS = False); // ½
      if NewCreated then begin
        LocalFileName := LocalFileName + '_ʹ' + IntToStr(GetTickCount);
        SetFileName(ExtractFileName(LocalFileName));  // ָı䣬Է
      end;
    end;

    // 򿪻½
    FAttachment := TIOCPDocument.Create(LocalFileName, NewCreated);

    if (FAttachment.Handle > 0) then  // Handle Чʱ = 0
    begin
      if NewCreated then  // ½ļ
      begin
        FAttachment.SetFileInf(Self); // ļ
        FOffset := 0;  // ʱҪ¿ʼ
      end;
      if (FAction in FILE_CHUNK_ACTIONS) then
        FAttachment.Position := FOffset;  // дλ
      FError := False;
    end;
  except
    FAttachment.Free;
    FAttachment := nil;
  end;
end;

destructor TReceivePack.Destroy;
begin
  if Assigned(FMain) then
  begin
    FMain.Free;
    FMain := nil;  //  Clear 쳣
  end;
  inherited;
end;

procedure TReceivePack.Write(AData: PPerIOData);
var
  Msg: PMsgHead;
begin
  // ѶϢд AData TBaseMessage.LoadHead
  // ʽIOCP_HEAD_FLAG + TMsgHead + [ԭʼ]
  
  if (IOCP_SOCKET_SIZE + FSize > BROADCAST_MAX_SIZE) then
    Exit;

  // 1. д C/S ־
  System.Move(IOCP_SOCKET_FLAG[1], AData^.Data.buf^, IOCP_SOCKET_FLEN);

  // 2. дЭͷ
  Msg := PMsgHead(AData^.Data.buf + IOCP_SOCKET_FLEN);
  GetHeadMsg(Msg);  // 

  // 3. =0У룬ѹ
  Msg^.AttachSize := 0;
  Msg^.CheckType := ctNone;
  Msg^.DataSize := FSize;
  Msg^.ZipLevel := zcNone;

  // 4. дֶ
  WriteBuffers(AData^.Data.buf + IOCP_SOCKET_SIZE);

  // 5. ڴݳ
  AData^.Data.len := IOCP_SOCKET_SIZE + FSize;
  AData^.Overlapped.InternalHigh := AData^.Data.len;  // 

end;

{ TBaseMessage }

procedure TBaseMessage.CreateStreams(ClearList: Boolean);
var
  mStream: TStream;
begin
  // ׼Ҫ͵
  //   1. ļѹ
  //   2. 壺 -> 

  FError := False;
  FVarCount := FList.Count;     // 

  // 1. ȴҪ

  if (FAction = atUnknown) then  // 1. Ӧ
  begin
    FAttachFileName := '';
    InterSetAttachment(nil);
  end else

  if (FAttachFileName <> '') then  // 2. ļ
  begin
    if not Assigned(FAttachment) then // ϵʱѴ
    begin
      OpenLocalFile;
      if FError and Assigned(FMain) then  // 쳣
        FMain.Clear;
    end;
  end else

  if Assigned(FAttachment) and (FZipLevel <> zcNone) and // 3. 
    (FAttachZiped = False) and not (FAction in FILE_CHUNK_ACTIONS) then  // δѹǷֿ鴫
  begin
    FAttachZiped := True;
    mStream := TIOCPDocument.Create;
    iocp_zlib.ZCompressStream(FAttachment, mStream);
    InterSetAttachment(mStream);  // Զͷе FStream
  end;
        
  // 2. 
  //    Variant ʱ FVarCount = 0

  if (FVarCount > 0) then // б
  begin
    FDataSize := FSize;   // ռ䳤
    if (FZipLevel = zcNone) or (FAction in FILE_CHUNK_ACTIONS) then
      SaveToStream(FMain, False)  // 
    else begin  // ѹ
      mStream := TMemoryStream.Create;
      try
        SaveToStream(mStream, False);  // 
        iocp_zlib.ZCompressStream(mStream, FMain);  // ѹ FMain
        FDataSize := FMain.Size;  // ı
        FMain.Position := 0;
      finally
        mStream.Free;
      end;
    end;
    if ClearList then  // 
      inherited Clear;
  end;

end;

procedure TBaseMessage.AdjustTransmitRange(ChunkSize: Integer);
begin
  // ䷶Χϵ㴫䣩
  //   Ҫȴļ FOffsetFAttachSize
  if (FOffset + ChunkSize <= FAttachSize) then
  begin
    FAttachSize := ChunkSize;  // ÿϴ
    FOffsetEnd := FOffset + ChunkSize - 1;  // ֹλ
  end else
  begin
    FOffsetEnd := FAttachSize - 1;
    Dec(FAttachSize, FOffset);
  end;
end;

procedure TBaseMessage.Clear;
begin
  //  Դ
  //    δͷ FAttachmentTReturnResult.ReturnResult
  FVarCount := 0;
  FDataSize := 0;
  FAttachSize := 0;
  FAttachFileName := '';
  if Assigned(FAttachment) then
    FreeAndNil(FAttachment);
  inherited;
end;

constructor TBaseMessage.Create(AOwner: TObject);
begin
  inherited Create;
  FMain := TInMemStream.Create; // 
  FAction := atUnknown;    // δ֪
  FZipLevel := zcNone;     // ѹ
  if Assigned(AOwner) then // ǿͻ
  begin
    FOwner := TMessageOwner(AOwner);
    FMsgId := GetUTCTickCountEh(Self);
  end;
end;

class procedure TBaseMessage.CreateHead(ABuf: PAnsiChar; AResult: TActionResult);
begin
  // ˣһϢܾ񡢳ʱɾ
  System.Move(IOCP_SOCKET_FLAG[1], ABuf^, IOCP_SOCKET_FLEN); // C/S ־
  with PMsgHead(ABuf + IOCP_SOCKET_FLEN)^ do
  begin
    Owner := 0;
    MsgId := 0;
    DataSize := 0;
    AttachSize := 0;
    Target := 0;
    VarCount := 0;
    Action := atServerEvent;
    ActResult := AResult;
  end;
end;

destructor TBaseMessage.Destroy;
begin
  // ͷ
  //    NilStreams ͷ FAttachment
  if Assigned(FMain) then
    FMain.Free;
  inherited;
end;

procedure TBaseMessage.GetCheckCode(AStream: TStream; ToBuf: PAnsiChar;
                                    ASize: TFileSize; var Offset: Cardinal);
begin
  // ͸У
  //   TBaseReceiver.GetCheckCodes
  case FCheckType of
    ctMurmurHash: begin  // MurmurHash У
      if (AStream is TMemoryStream) then  // 
        PMurmurHash(ToBuf)^ := iocp_mmHash.MurmurHash64(TMemoryStream(AStream).Memory, ASize)
      else
      if (FAction in FILE_CHUNK_ACTIONS) then  // ļһ
        PMurmurHash(ToBuf)^ := iocp_mmHash.MurmurHashPart64(TIOCPDocument(AStream).Handle,
                                                            FOffset, FAttachSize)
      else  // ļ
        PMurmurHash(ToBuf)^ := iocp_mmHash.MurmurHash64(TIOCPDocument(AStream).Handle);
      Inc(Offset, HASH_CODE_SIZE);
    end;
    ctMD5: begin  // MD5 У
      if (AStream is TMemoryStream) then  // 
        PMD5Digest(ToBuf)^ := iocp_md5.MD5Buffer(TMemoryStream(AStream).Memory, ASize)
      else
      if (FAction in FILE_CHUNK_ACTIONS) then  // ļһ
        PMD5Digest(ToBuf)^ := iocp_md5.MD5Part(TIOCPDocument(AStream).Handle,
                                               FOffset, FAttachSize)
      else  // ļ
        PMD5Digest(ToBuf)^ := iocp_md5.MD5File(TIOCPDocument(AStream).Handle);
      Inc(Offset, HASH_CODE_SIZE * 2);
    end;
  end;
end;

procedure TBaseMessage.GetFileInfo(const AFileName: String);
var
  FileSize: TFileSize;
  CreationTime, AccessTime, LastWriteTime: TFileTime;
begin
  // ȡļϢ32λСļ̫󣩡ʱ
  //   TIOCPDocument.SetFileInf
  GetLocalFileInf(AFileName, FileSize, CreationTime, AccessTime, LastWriteTime);
  SetFileSize(FileSize);
  AsCardinal['_creationLow'] := CreationTime.dwLowDateTime;
  AsCardinal['_creationHigh'] := CreationTime.dwHighDateTime;
  AsCardinal['_accessLow'] := AccessTime.dwLowDateTime;
  AsCardinal['_accessHigh'] := AccessTime.dwHighDateTime;
  AsCardinal['_modifyLow'] := LastWriteTime.dwLowDateTime;
  AsCardinal['_modifyHigh'] := LastWriteTime.dwHighDateTime;
end;

procedure TBaseMessage.InterSetAttachment(AStream: TStream);
begin
  // ø
  if Assigned(FAttachment) then
    FAttachment.Free;
  FAttachment := AStream;
  if Assigned(FAttachment) then
  begin
    FAttachSize := FAttachment.Size;
    FAttachment.Position := 0;  // 
    if (FAction <> atFileUpChunk) and  // ļУǳʱȡ
       (FAttachSize > MAX_CHECKCODE_SIZE) and (FCheckType > ctNone) then
      FCheckType := ctNone;
  end else
    FAttachSize := 0;
end;

procedure TBaseMessage.LoadHead(Data: PWsaBuf);
var
  Msg: PMsgHead; 
begin
  // ЭͷϢ
  //   װIOCP_HEAD_FLAG + TMsgHead + [У + У] + [ԭʼ]
  Data^.len := IOCP_SOCKET_SIZE;  // ݳ
  Msg := PMsgHead(Data^.buf + IOCP_SOCKET_FLEN);

  System.Move(IOCP_SOCKET_FLAG[1], Data^.buf^, IOCP_SOCKET_FLEN); // C/S ־
  GetHeadMsg(Msg);  // Эͷ

  // У
  if (FCheckType > ctNone) then
  begin
    if (FDataSize > 0) then
      GetCheckCode(FMain, Data^.buf + Data^.len, FDataSize,  Data^.len);
    if (FAttachSize > 0) then
      GetCheckCode(FAttachment, Data^.buf + Data^.len, FAttachSize, Data^.len);
  end;

  // ӿݷͣFHeader ݲʱһͣ
  //   շռƣΪ IO_BUFFER_SIZE
  if (FDataSize > 0) and (IO_BUFFER_SIZE >= FDataSize + Data^.len) then
  begin
    System.Move(FMain.Memory^, (Data^.buf + Data^.len)^, FDataSize);
    Inc(Data^.len, FDataSize);
    FMain.Clear;     // 
    FDataSize := 0;  //         
  end;
end;

procedure TBaseMessage.LoadFromFile(const AFileName: String; ServerMode: Boolean);
begin
  // Ҫļ
  if FileExists(AFileName) then
  begin
    FError := False;
    FAttachFileName := AFileName;
    if (FZipLevel = zcNone) then
      FZipLevel := GetCompressionLevel(FAttachFileName);  // ѹ

    GetFileInfo(FAttachFileName);  // ļϢ
    SetFileName(ExtractFileName(FAttachFileName));  // շļ

    if ServerMode then  // 
      OpenLocalFile;  // ̴򿪣ֹɾ
  end else
  begin
    FAttachFileName := '';
    FError := True;
  end;
end;

procedure TBaseMessage.LoadFromStream(AStream: TStream; AZipCompressIt: Boolean);
var
  mStream: TStream;
begin
  // Ҫ
  //   ڲѹͨ ZipLevel Ϊѹ
  if Assigned(AStream) then
  begin
    if AZipCompressIt then
      FZipLevel := zcDefault;
    FAttachZiped := (FZipLevel <> zcNone);

    if (FZipLevel = zcNone) then
      InterSetAttachment(AStream)
    else
    if Assigned(AStream) then  // ѹļ
    begin
      mStream := TIOCPDocument.Create;
      try
        iocp_zlib.ZCompressStream(AStream, mStream);
        InterSetAttachment(mStream);
      finally
        AStream.Free;  // ͷ
      end;
    end;

    // ļ
    inherited SetFileName('_stream.strm');
  end;
end;

procedure TBaseMessage.LoadFromVariant(
  const AProviders: array of TDataSetProvider;
  const ATableNames: array of String);
var
  i: Integer;
begin
  //  Variant 飨ݼбATableNames Ϊݱ
  //  [ݼa, ݼb, ݼc], ['ݱa', 'ݱb', 'ݱc']
  //        ݱn  ݼn Ӧݱƣڸ
  // жݼһΪ
  if (High(AProviders) = High(ATableNames)) then
    for i := 0 to High(ATableNames) do
      AsVariant[ATableNames[i]] := AProviders[i].Data;  // 
end;

procedure TBaseMessage.NilStreams(CloseAttachment: Boolean);
begin
  // ϣԴ
  //   C/S ģʽݷԶظ
  //   TClientParams.InternalSendTReturnResult.ReturnResult;
  if (FSize > 0) then
    inherited Clear;
  FDataSize := 0;
  FVarCount := 0;
  FAttachSize := 0;
  FAttachFileName := '';
  if Assigned(FMain.Memory) then
    FMain.Clear;
  if Assigned(FAttachment) and CloseAttachment then
    FreeAndNil(FAttachment);
end;

procedure TBaseMessage.OpenLocalFile;
var
  mStream, mZStream: THandleStream;
begin
  // Ҫļ
  mStream := TIOCPDocument.CreateEx(FAttachFileName);
  if (mStream.Handle > 0) then
  begin
    if (mStream.Size > 1021*1024*32) then  // ļ̫󣬲ѹ
      FZipLevel := zcNone;
    if (FZipLevel = zcNone) or (FAction in FILE_CHUNK_ACTIONS) then
      InterSetAttachment(mStream)
    else begin
      // ѹʱļ!
      mZStream := TIOCPDocument.Create;
      try
        iocp_zlib.ZCompressStream(mStream, mZStream, zcDefault);
        InterSetAttachment(mZStream);  // ǰ
        SetFileSize(FAttachSize);  // ں󣬵ļС
      finally
        mStream.Free;  // ͷԭļ
      end;
    end;
  end else
  begin
    mStream.Free;
    InterSetAttachment(nil);
    FError := True;
  end;
end;

{ TMessageWriter }

constructor TMessageWriter.Create(SurportHttp: Boolean);
begin
  inherited Create;
  FSurportHttp := SurportHttp;
  FLock := TThreadLock.Create;
end;

destructor TMessageWriter.Destroy;
begin
  FLock.Free;
  inherited;
end;

procedure TMessageWriter.LoadMsg(const UserName: String; Msg: TBaseMessage);
var
  FileName, NewFileName: String;
begin
  // ûϢļ
  //   ûΪ Params.UserNameϢļװ
  //   Ҫֱ Msg.LoadFromFile ķ

  // ļûϢĿ¼
  FileName := iocp_varis.gUserDataPath + UserName + '\msg\main.msg';
  NewFileName := FileName + '_' + IntToStr(GetUTCTickCount);

  FLock.Acquire;
  try
    if FileExists(FileName) then
      RenameFile(FileName, NewFileName)  // ļ
    else
      Exit;
  finally
    FLock.Release;
  end;

  // ̴ļ True
  Msg.LoadFromFile(NewFileName, True);

end;

procedure TMessageWriter.SaveMsg(Data: PPerIOData; const ToUser: String);
var
  Count: Integer;    // Ϣ
  iValue: Cardinal;
  Handle: THandle;
  Rec: TStreamVariable;
begin
  // дϢļ
  // յݿ鱣浽ļת̣
  // ٶȸ죬ܼ븽 URL 
  // ļʽOFFLINE_MSG_FLAG + ElementCount + Record... ...

  Rec.EleType := etRecord; // һ¼
  Rec.NameSize := 0; // ûм¼

  FLock.Acquire;

  // /½ϢļԶļ־
  // InternalOpenMsgFile  INVALID_HANDLE_VALUE תΪ 0
  Handle := InternalOpenMsgFile(iocp_varis.gUserDataPath +
                                ToUser + '\msg\main.msg', True);

  try
    if (Handle > 0) then
    begin
      // Ϣ
      Count := 0;
      ReadFile(Handle, Count, SizeOf(Integer), iValue, nil);

      // Ϣ + 1 OFFLINE_MS_FLAG д
      Inc(Count);  // +

      SetFilePointer(Handle, SizeOf(Integer), nil, FILE_BEGIN);
      WriteFile(Handle, Count, SizeOf(Integer), iValue, nil);

      // ļĩλãдϢ
      SetFilePointer(Handle, 0, nil, FILE_END);

      WriteFile(Handle, Rec, STREAM_VAR_SIZE, iValue, nil);   // 1.д
      WriteFile(Handle, (Data^.Data.buf + IOCP_SOCKET_FLEN)^, // 2.д Data
                        Data^.Overlapped.InternalHigh - IOCP_SOCKET_FLEN,
                        iValue, nil);
    end;
  finally
    if (Handle > 0) then
      CloseHandle(Handle);
    FLock.Release;
  end;
end;

procedure TMessageWriter.SaveMsg(Msg: THeaderPack; const ToUser: String);
var
  Count: Integer;    // Ϣ
  iSize, iValue: Cardinal;
  Handle: THandle;
  Buffer: PAnsiChar;
begin
  // дϢļ
  // ļʽOFFLINE_MSG_FLAG + ElementCount + Record... ...

  // ʱ· gTempDirectoryշ Params.ToUser
  // תΪ JSONMsg Ϊ THeaderPackԱ TReceivePackTSendMessage

  if FSurportHttp and (Msg is TReceivePack) then
    if Assigned(TReceivePack(Msg).Attachment) then
    begin
      // 븽 URL 
      // <a href="/web_site/downloads/filename.doc">FileName.doc</a>
      Msg.SetURL('<a href="' + Msg.GetURL + '">' +
          ExtractFileName(TReceivePack(Msg).Attachment.FileName) + '</a>');
    end;

  // Msg תΪ¼
  Msg.ToRecord(Buffer, iSize);

  // 
  FLock.Acquire;

  // /½ϢļԶļ־
  // ûʱΪÿûһݵĿ¼
  // MyCreateDir(gTempDirectory + Msg.GetToUser);

  // InternalOpenMsgFile  INVALID_HANDLE_VALUE תΪ 0
  Handle := InternalOpenMsgFile(iocp_varis.gUserDataPath +
                                ToUser + '\msg\main.msg', True);

  try
    if (Handle > 0) then
    begin
      // Ϣ
      Count := 0;
      ReadFile(Handle, Count, SizeOf(Integer), iValue, nil);

      // Ϣ + 1 OFFLINE_MS_FLAG д
      Inc(Count);  // +

      SetFilePointer(Handle, SizeOf(Integer), nil, FILE_BEGIN);
      WriteFile(Handle, Count, SizeOf(Integer), iValue, nil);

      // ļĩλã Buffer дļ
      SetFilePointer(Handle, 0, nil, FILE_END);
      WriteFile(Handle, Buffer^, iSize, iValue, nil);
    end;
  finally
    FreeMem(Buffer);
    if (Handle > 0) then
      CloseHandle(Handle);
    FLock.Release;
  end;
end;

{ TMessageReader }

procedure TMessageReader.Close;
begin
  // ļ
  FCount := 0;
  if (FHandle > 0) then
    CloseHandle(FHandle);
end;

destructor TMessageReader.Destroy;
begin
  Close;
  inherited;
end;

function TMessageReader.Extract(Msg: TReceivePack; LastMsgId: TIOCPMsgId): Boolean;
var
  Rec: TStreamVariable;
  MsgHead: TMsgHead;
  EleType, iCount: Cardinal;
  function LocateNewMessage: Boolean;
  begin
    // Эͷ
    ReadFile(FHandle, Rec, STREAM_VAR_SIZE, EleType, nil);
    ReadFile(FHandle, MsgHead, MSG_HEAD_SIZE, iCount, nil);
    if (EleType <> STREAM_VAR_SIZE) or (iCount <> MSG_HEAD_SIZE) then
    begin
      Result := False;
      Rec.EleType := etNull;
    end else begin
      Result := (LastMsgId = 0) or (MsgHead.MsgId > LastMsgId);
      if (Result = False) then  // ƽһλ
        SetFilePointer(FHandle, MsgHead.DataSize, nil, FILE_CURRENT);
    end;
  end;
var
  Buffer: PAnsiChar;
begin
  // ȡһϢ¼
  // LastMsgId ΪѶϢ id id Ϣ
  // LastMsgId = 0 -> ȫ
  // ļʽOFFLINE_MSG_FLAG + ElementCount + Record... ...

  Msg.Clear;
  Msg.FAction := atUnknown;

  // 
  while (LocateNewMessage = False) and (Rec.EleType <> etNull) do
    { ҵһ¼¼MsgId > LastMsgId } ;

  // Ϣ
  Result := (Rec.EleType <> etNull);
  
  if Result then
  begin
    Msg.SetHeadMsg(@MsgHead);  // Эͷ
    GetMem(Buffer, MsgHead.DataSize);
    try
      ReadFile(FHandle, Buffer^, MsgHead.DataSize, iCount, nil);
      if (MsgHead.DataSize = iCount) then
      begin
        Msg.ScanBuffers(Buffer, MsgHead.DataSize);
        Result := True;
      end;
    finally
      FreeMem(Buffer);
    end;
  end;
  
end;

procedure TMessageReader.Open(const FileName: String);
var
  iValue: Cardinal;
begin
  // Ϣļ
  // InternalOpenMsgFile  INVALID_HANDLE_VALUE תΪ 0
  FHandle := InternalOpenMsgFile(FileName);  // Զļ־
  if (FHandle > 0) then  // ϢϢ
    ReadFile(FHandle, FCount, SizeOf(Integer), iValue, nil)
  else
    FCount := 0;
end;

end.
