(*
 * iocp ر̡߳ҵ̵̡߳߳
 *)
unit iocp_threads;

interface

{$I in_iocp.inc}        // ģʽ

uses
  {$IFDEF DELPHI_XE7UP}
  Winapi.Windows, System.Classes, System.SysUtils, Winapi.ActiveX, {$ELSE}
  Windows, Classes, SysUtils, ActiveX, {$ENDIF}
  iocp_base, iocp_lists, iocp_objPools,
  iocp_winSock2, iocp_baseObjs, iocp_sockets,
  iocp_managers, iocp_msgPacks, iocp_senders;

type

  // ===================== רŹر Socket ߳ =====================

  TCloseSocketThread = class(TCycleThread)
  private
    FLock: TThreadLock;   // 
    FSockets: TInList;    // ɾ׽ڵб
  protected
    procedure AfterWork; override;
    procedure DoMethod; override;
  public
    constructor Create;
    procedure AddSocket(const Socket: TBaseSocket);
    procedure WaitFor;    // 
  end;

  // ===================== ִҵ߳ =====================

  TBusiWorkManager = class;

  TBusiThread = class(TCycleThread)
  private
    FManager: TBusiWorkManager; // 
    FSender: TServerTaskSender; // ã
    FSocket: TBaseSocket;       // ǰ׽ֶ
    FWorker: TBusiWorker;       // ִߣã
  protected
    procedure AfterWork; override;
    procedure DoMethod; override;
  public
    constructor Create(AManager: TBusiWorkManager);
  end;

  // ===================== ҵ̵߳ȹ =====================

  TBusiWorkManager = class(TObject)
  private
    FServer: TObject;            // TInIOCPServer
    FSemaphore: THandle;         // ̹߳źŵ

    // ߳
    FThreads: Array of TBusiThread;

    FThreadCount: Integer;       // ߳
    FLock: TThreadLock;          // 

    FSockets: TInList;           // ɾ׽ڵбܴܺ
    FBackSockets: TInList;       // бܴܺɾģʱã
    FCurrentList: TInList;       //  FSockets/FBackSockets

    FActiveCount: Integer;       // 
    FActiveThreadCount: Integer; // ߳
    FWorkTotalCount: IOCP_LARGE_INTEGER;  // ִе
    
    function CreateWorker(Index: Integer): TBusiWorker;
    function GetDataModuleState(Index: Integer): Boolean;
    function GetWork(var Socket: TObject): Boolean;

    procedure InternalAddRemove(Index: Integer; AddMode: Boolean);
    procedure InternalStop;
  public
    constructor Create(AServer: TObject; AThreadCount: Integer);
    destructor Destroy; override;
    procedure AddWork(Socket: TObject; Activate: Boolean = True);
    procedure AddDataModule(Index: Integer);
    procedure RemoveDataModule(Index: Integer);
    procedure StopThreads;
    procedure WaitFor;
  public
    property ActiveCount: Integer read FActiveCount;
    property ActiveThreadCount: Integer read FActiveThreadCount;
    property DataModuleState[Index: Integer]: Boolean read GetDataModuleState;
    property WorkTotalCount: IOCP_LARGE_INTEGER read FWorkTotalCount;
  end;

  // ===================== Ͷ/ =====================

  TPushMessage = class(TInList)
  private
    FObjPool: TIOCPSocketPool;  // 
    FBufPool: TIODataPool;      // ڴ
    FPushBuf: PPerIOData;       // Ϣ
    FCastType: TBroadcastType;  // 㲥Ŀ
    FIngoreSocket: TObject;     // Թ㲥 TIOCPSocketPool
    FClientCount: Integer;      // ƹ㲥Ŀ
    FTickCount: Cardinal;       // ʱ
  public
    constructor Create(Msg: PPerIOData; BroadcastType: TBroadcastType = btUnknown); overload;
    constructor Create(ASocketPool: TIOCPSocketPool; ABufferPool: TIODataPool;
                       BroadcastType: TBroadcastType = btUnknown; MsgSize: Cardinal = 0); overload;
    constructor Create(Socket: TBaseSocket; IOKind: TIODataType; MsgSize: Cardinal); overload;
    destructor Destroy; override;
  public
    procedure UpdateMsgId;
    property IngoreSocket: TObject read FIngoreSocket write FIngoreSocket;
    property PushBuf: PPerIOData read FPushBuf;
  end;

  // ===================== Ϣ߳ =====================

  TPushMsgManager = class;

  TPushThread = class(TCycleThread)
  private
    FBusiManager: TBusiWorkManager;  // ҵ
    FPushManager: TPushMsgManager;   // ͹
    FMsg: TPushMessage;         // ǰϢ
    FSocket: TBaseSocket;       // ǰ׽ֶ
    procedure PushMesssage;
  protected
    procedure AfterWork; override;
    procedure DoMethod; override;
  public
    constructor Create(APushManager: TPushMsgManager; ABusiManager: TBusiWorkManager);
  end;

  // ===================== Ϣ =====================
  // 1. ʱҵ̣߳Socket ԴռãֱͶʱ
  //    ߳Դù
  // 2. ȰϢͶŵأÿһʱͶС
  
  TMsgPushPool = class(TBaseThread)
  private
    FLock: TThreadLock;          // Ϣ
    FManager: TPushMsgManager;   // 
    FMsgList: TInList;           // Ϣ
    procedure InterAdd(Msg: TPushMessage);
  protected
    procedure ExecuteWork; override;
  public
    constructor Create(AManager: TPushMsgManager);
    destructor Destroy; override;
  end;

  // ===================== Ϣ̹߳ =====================

  TPushMsgManager = class(TObject)
  private
    FSemaphore: THandle;         // ߳źŵ
    FWaitSemaphore: THandle;     // ̵߳ȴźŵ

    // ߳
    FThreads: array of TPushThread;
    FThreadCount: Integer;       // ߳
    FLock: TThreadLock;          // 

    FPushPool: TMsgPushPool;     // Ϣ
    FMsgList: TInList;           // Ϣб

    FActiveCount: Integer;       // б
    FActiveThreadCount: Integer; // ߳
    FPushMsgCount: Integer;      // Ϣ㣩

    // ٶȿ
    FMaxPushCount: Integer;      // ÿϢ
    FNowTickCount: Cardinal;     // ǰʱ
    FTickCount: Cardinal;        // ɵĺʱ
    FPushCountPS: Integer;       // ÿϢ

    function GetWork(var Msg: TPushMessage): Boolean;
    procedure ActivateThreads;
    procedure InterAdd(Msg: TPushMessage);
  public
    constructor Create(ABusiManger: TBusiWorkManager; AThreadCount, AMaxPushCount: Integer);
    destructor Destroy; override;
    function AddWork(Msg: TPushMessage): Boolean;
    procedure StopThreads;
    procedure WaitFor;
  public
    property ActiveCount: Integer read FActiveCount;
    property ActiveThreadCount: Integer read FActiveThreadCount;
    property PushMsgCount: Integer read FPushMsgCount;
  end;

implementation

uses
  iocp_api, iocp_Server,
  iocp_log, iocp_utils, http_objects;

type
  TBaseSocketRef = class(TBaseSocket);

{ TCloseSocketThread }

procedure TCloseSocketThread.AddSocket(const Socket: TBaseSocket);
begin
  // Ҫرյ Socket
  FLock.Acquire;
  try
    FSockets.Add(Socket);
  finally
    FLock.Release;
  end;
  Activate;  // 
end;

procedure TCloseSocketThread.AfterWork;
begin
  FLock.Free;
  FSockets.Free;  // ͷŽڵռ伴, ɳͷ
end;

constructor TCloseSocketThread.Create;
begin
  inherited Create;
  FLock := TThreadLock.Create;
  FSockets := TInList.Create;
end;

procedure TCloseSocketThread.DoMethod;
var
  Socket: TBaseSocket;
begin
  while (Terminated = False) do
  begin
    FLock.Acquire;
    try
      Socket := FSockets.PopFirst;  // ȡһɾ
      if (Socket = nil) then
        Exit;
    finally
      FLock.Release;
    end;
    try
      Socket.Close;
    finally
      Socket.ObjPool.Push(Socket.LinkNode);
    end;
  end;
end;

procedure TCloseSocketThread.WaitFor;
begin
  // ȴȫ Socket ر
  while (FSockets.Count > 0) do
    Sleep(10);
end;

{ TBusiThread }

procedure TBusiThread.AfterWork;
begin
  // ߳ -1
  InterlockedDecrement(FManager.FThreadCount);
  FSender.FreeBuffers(TInIOCPServer(FManager.FServer).IODataPool);  // ͷŷͻ
  FSender.Free;
end;

constructor TBusiThread.Create(AManager: TBusiWorkManager);
begin
  inherited Create(False);
  FManager := AManager;
  FSemaphore := FManager.FSemaphore;  // 
  FSender := TServerTaskSender.Create(TInIOCPServer(FManager.FServer).IODataPool);
end;

procedure TBusiThread.DoMethod;
begin
  // ȡбһ Socketִ
  while (Terminated = False) and
         FManager.GetWork(TObject(FSocket)) do
    case TBaseSocketRef(FSocket).Lock(False) of  // ģʽ

      SOCKET_LOCK_OK: begin  // ɹ
        InterlockedIncrement(FManager.FActiveThreadCount);  // ҵ߳+
        try
          TBaseSocketRef(FSocket).DoWork(FWorker, FSender)  //  FWorker, FSender
        finally
          InterlockedDecrement(FManager.FActiveThreadCount); // ҵ߳-
          {$IFDEF WIN_64}
          System.AtomicIncrement(FManager.FWorkTotalCount);  // ִ+
          {$ELSE}
          InterlockedIncrement(FManager.FWorkTotalCount);  // ִ+
          {$ENDIF}
        end;
      end;

      SOCKET_LOCK_FAIL:  // ɹ¼б´Σ
        FManager.AddWork(FSocket, False);  // 

      else
        { Ѿر, ڵ Socket } ;
    end;
end;

{ TBusiWorkManager }

procedure TBusiWorkManager.AddDataModule(Index: Integer);
begin
  // ½Ϊ Index ģҪעģ
  InternalAddRemove(Index, True);
end;

procedure TBusiWorkManager.AddWork(Socket: TObject; Activate: Boolean);
begin
  // ̵߳ã

  // 1. һ
  FLock.Acquire;
  try
    FCurrentList.Add(Socket);
    if (FCurrentList = FSockets) then  // δıб
      FActiveCount := FCurrentList.Count;
  finally
    FLock.Release;
  end;

  // 2. ҵ̣߳ȡ
  if Activate and (FCurrentList = FSockets) then  // б
    ReleaseSemapHore(FSemaphore, 8, Nil);

end;

constructor TBusiWorkManager.Create(AServer: TObject; AThreadCount: Integer);
var
  i: Integer;
  Thread: TBusiThread;
begin
  inherited Create;

  // ÿ̶߳Ӧһҵ̣߳1:n

  // 1. źŵƣֵ = MaxInt
  FSemaphore := CreateSemapHore(Nil, 0, MaxInt, Nil);

  // 2. ҵ߳
  FServer := AServer;
  FThreadCount := AThreadCount;

  SetLength(FThreads, FThreadCount);

  // 3. Socket б
  FLock := TThreadLock.Create;

  FSockets := TInList.Create;        // б
  FBackSockets := TInList.Create;    // б
  FCurrentList := FSockets;          // б

  // 4. ҵִ̡߳
  for i := 0 to FThreadCount - 1 do
  begin
    Thread := TBusiThread.Create(Self);
    Thread.FWorker := CreateWorker(i);
    FThreads[i] := Thread;
    Thread.Resume;
  end;
end;

function TBusiWorkManager.CreateWorker(Index: Integer): TBusiWorker;
begin
  // Ϊ߳̽һҵ
  //   ģ DatabaseManager  TBusiThread.FWorker ͷ
  Result := TBusiWorker.Create(FServer, Index);
  Result.CreateDataModules;  // ʵ
end;

destructor TBusiWorkManager.Destroy;
begin
  InternalStop;  // Ҫȵȴִ
  inherited;
end;

function TBusiWorkManager.GetDataModuleState(Index: Integer): Boolean;
begin
  // ģǷʵ
  Result := TBusiWorker(FThreads[0].FWorker).DataModules[Index] <> nil;
end;

function TBusiWorkManager.GetWork(var Socket: TObject): Boolean;
begin
  // һ
  FLock.Acquire;
  try
    Socket := FSockets.PopFirst;
    FActiveCount := FSockets.Count;
    Result := (Socket <> nil);
  finally
    FLock.Release;
  end;
end;

procedure TBusiWorkManager.InternalAddRemove(Index: Integer; AddMode: Boolean);
  procedure StartBackSocketList;
  begin
    // ñб洢
    //  AddWork ҵ̣߳
    FLock.Acquire;
    try
      if (FCurrentList = FSockets) then
        FCurrentList := FBackSockets
      else
        FCurrentList := FSockets;
    finally
      FLock.Release;
    end;
  end;
  procedure SetMainSocketList;
  begin
    // б
    //  AddWork ҵ̣߳GetWork µ FSockets ȡ
    FLock.Acquire;
    try
      FCurrentList := FBackSockets;  // ǰñ
      FBackSockets := FSockets;      //  -> 
      FSockets := FCurrentList;      //  -> 
    finally
      FLock.Release;
    end;
  end;
var
  i: Integer;
begin
  // ɾ½Ϊ Index ģʵ
  StartBackSocketList;
  try
    while (FActiveThreadCount > 0) do  // Ȼִ߳
      Sleep(10);
    for i := 0 to FThreadCount - 1 do  // /ɾÿִߵĶӦģʵ
      if AddMode then
        TBusiWorker(FThreads[i].FWorker).AddDataModule(Index)
      else
        TBusiWorker(FThreads[i].FWorker).RemoveDataModule(Index);
  finally
    SetMainSocketList;
  end;
end;

procedure TBusiWorkManager.InternalStop;
var
  i: Integer;
begin
  if Assigned(FLock) then
  begin
    for i := 0 to FThreadCount - 1 do // ֹͣ߳
    begin
      FThreads[i].FWorker.Free;  // FWorker Զͷģ
      FThreads[i].Stop;
    end;

    while (FThreadCount > 0) do  // ȴȫ߳˳
    begin
      ReleaseSemapHore(FSemaphore, 1, Nil);
      Sleep(10);
    end;

    SetLength(FThreads, 0);
    CloseHandle(FSemaphore);  // ر
    
    FLock.Free;
    FSockets.Free;
    FBackSockets.Free;

    FLock := Nil;
    FSockets := nil;
    FBackSockets := nil;
  end;
end;

procedure TBusiWorkManager.RemoveDataModule(Index: Integer);
begin
  // ɾΪ Index ģʵı FThreads ȣ
  InternalAddRemove(Index, False);
end;

procedure TBusiWorkManager.StopThreads;
begin
  InternalStop;
end;

procedure TBusiWorkManager.WaitFor;
begin
  // ȴ߳̽
  while (FActiveThreadCount > 0) do
    Sleep(10);
end;

{ TPushMessage }

constructor TPushMessage.Create(Msg: PPerIOData; BroadcastType: TBroadcastType);
begin
  inherited Create;
  // ϢбĿͻˣ㲥
  FCastType := BroadcastType;
  FTickCount := GetTickCount;  // ǰʱ
  FObjPool := TBaseSocket(Msg^.Owner).ObjPool;
  FBufPool := TBaseSocket(Msg^.Owner).BufferPool;

  FPushBuf := FBufPool.Pop^.Data;

  FPushBuf^.IOType := ioPush; // 
  FPushBuf^.Data.len := Msg^.Overlapped.InternalHigh; // ϢС
  FPushBuf^.Overlapped.InternalHigh := FPushBuf^.Data.len; // ϢС

  //  Msg
  System.Move(Msg^.Data.buf^, FPushBuf^.Data.buf^, FPushBuf^.Data.len);
end;

constructor TPushMessage.Create(ASocketPool: TIOCPSocketPool;
  ABufferPool: TIODataPool; BroadcastType: TBroadcastType; MsgSize: Cardinal);
begin
  inherited Create;
  // 㲥һϢⲿ FPushBuf 
  FCastType := BroadcastType;
  FTickCount := GetTickCount;  // ǰʱ
  FObjPool := ASocketPool;
  FBufPool := ABufferPool;

  FPushBuf := FBufPool.Pop^.Data;

  FPushBuf^.IOType := ioPush; // ̶ = ioPush
  FPushBuf^.Data.len := MsgSize;  // ݳ
  FPushBuf^.Overlapped.InternalHigh := MsgSize;
end;

constructor TPushMessage.Create(Socket: TBaseSocket; IOKind: TIODataType; MsgSize: Cardinal);
begin
  inherited Create;
  // һ Socket  IOKind ϢⲿϢ
  FCastType := btUnknown;  // ǹ㲥
  FTickCount := GetTickCount;  // ǰʱ
  FObjPool := Socket.ObjPool;
  FBufPool := Socket.BufferPool;

  FPushBuf := FBufPool.Pop^.Data;

  FPushBuf^.IOType := IOKind; // 
  FPushBuf^.Data.len := MsgSize;  // ݳ
  FPushBuf^.Overlapped.InternalHigh := MsgSize;

  inherited Add(Socket); // ֻһڵ
end;

destructor TPushMessage.Destroy;
begin
  FBufPool.Push(FPushBuf^.Node);
  inherited;
end;

procedure TPushMessage.UpdateMsgId;
var
  MsgHead: PMsgHead;
begin
  // ʹµ MsgId
  MsgHead := PMsgHead(FPushBuf^.Data.buf + IOCP_SOCKET_FLEN);
  MsgHead^.MsgId := TSystemGlobalLock.GetMsgId;
end;

{ TPushThread }

procedure TPushThread.AfterWork;
begin
  // ߳ -1
  InterlockedDecrement(FPushManager.FThreadCount);
end;

constructor TPushThread.Create(APushManager: TPushMsgManager; ABusiManager: TBusiWorkManager);
begin
  inherited Create(False);
  FBusiManager := ABusiManager;
  FPushManager := APushManager;
  FSemaphore := APushManager.FSemaphore;  // 
end;

procedure TPushThread.DoMethod;
var
  i: Integer;
  Trigger: Boolean;
begin
  //  TPushMessage.FPushBuf  TPushMessage бû
  //   ֻҪûر SocketһҪһ

  Trigger := False;
  while (Terminated = False) and FPushManager.GetWork(FMsg) do
  begin
    // 1. 㲥߿ͻб
    if (FMsg.FCastType > btUnknown) then
    begin
      FMsg.FObjPool.GetSockets(FMsg, FMsg.FIngoreSocket, FMsg.FCastType = btAdminOnly);
      FMsg.FCastType := btUnknown;  // ֻȡڴʱĿͻ
    end;

    // 2. һ
    for i := 1 to FMsg.Count do
    begin
      FSocket := FMsg.PopFirst;  // Ŀ
      FMsg.FPushBuf^.Owner := FSocket;
      if FSocket.Active then
        PushMesssage;
    end;

    // ҵ߳ Socket Դһ
    WaitForSingleObject(FPushManager.FWaitSemaphore, 10);

    // 3. 
    if (FMsg.Count > 0) then // δȫ
    begin
      Trigger := True;
      FPushManager.InterAdd(FMsg);  // ټ
      Break;  // ´μ
    end else
    begin
      Trigger := False;
      FMsg.Free;  // ȫͷ
    end;
  end;

  if Trigger then
    FPushManager.ActivateThreads;
    
end;

procedure TPushThread.PushMesssage;
begin
  //  FMsg.FPushBuf  FSocket
  case TBaseSocketRef(FSocket).Lock(True) of

    SOCKET_LOCK_OK: begin  // ɹ
      // ͳƵ FTotalCount
      InterlockedIncrement(FPushManager.FActiveThreadCount); // ߳+
      try
        TBaseSocketRef(FSocket).InternalPush(FMsg.FPushBuf); // 
      finally
        InterlockedDecrement(FPushManager.FActiveThreadCount); // ҵ߳-
        {$IFDEF WIN_64}
        System.AtomicIncrement(FBusiManager.FWorkTotalCount);  // ִ+
        {$ELSE}
        InterlockedIncrement(FBusiManager.FWorkTotalCount);  // ִ+
        {$ENDIF}
      end;
    end;

    SOCKET_LOCK_FAIL:  // ɹ
      //  Socket رٴδӳȡʱԭĿͻˣ
      // Ҳһ㲥ĿͻˣԽչ㲥Ϣ
      FMsg.Add(FSocket);  // ¼룬´Σ

    else
      { Ѿر, ڵ Socket } ;

  end;
end;

{ TMsgPushPool }

constructor TMsgPushPool.Create(AManager: TPushMsgManager);
begin
  inherited Create(True);
  FManager := AManager;
  FreeOnTerminate := True;  
  FLock := TThreadLock.Create;
  FMsgList := TInList.Create;
  Resume;
end;

destructor TMsgPushPool.Destroy;
var
  i: Integer;
begin
  for i := 0 to FMsgList.Count - 1 do
    TPushMessage(FMsgList.PopFirst).Free;
  FMsgList.Free;
  FLock.Free;
  // FManager ߳-
  InterlockedDecrement(FManager.FThreadCount);
  inherited;  
end;

procedure TMsgPushPool.ExecuteWork;
const
  WAIT_MILLSECONDS = 50;  // 
var
  i: Integer;
  Trigger: Boolean;
  NowTickCount: Cardinal;
  Msg: TPushMessage;
  function GetTickCountDiff: Boolean;
  begin
    if (NowTickCount >= Msg.FTickCount) then
      Result := NowTickCount - Msg.FTickCount >= WAIT_MILLSECONDS  // n 
    else
      Result := High(Cardinal) - Msg.FTickCount + NowTickCount >= WAIT_MILLSECONDS;
  end;
begin
  // ÿ n ѭһΣ
  // еϢǷҪͶŵͶС
  while (Terminated = False) do
  begin
    Sleep(WAIT_MILLSECONDS);  //  n 
    FLock.Acquire;
    try
      Trigger := False;
      NowTickCount := GetTickCount;
      for i := 1 to FMsgList.Count do
      begin
        Msg := FMsgList.PopFirst;
        if GetTickCountDiff then  // ʱ n 
        begin
          FManager.InterAdd(Msg); // ʽͶ
          Trigger := True;
        end else
          FMsgList.Add(Msg);  // ¼
      end;
      if Trigger then  // 
        FManager.ActivateThreads;
    finally
      FLock.Release;
    end;
  end;
end;

procedure TMsgPushPool.InterAdd(Msg: TPushMessage);
begin
  // Ϣӵб
  FLock.Acquire;
  try
    FMsgList.Add(Msg);
  finally
    FLock.Release;
  end;
end;

{ TPushMsgManager }

procedure TPushMsgManager.ActivateThreads;
var
  Trigger: Boolean;
begin
  // ߳
  FLock.Acquire;
  try
    Trigger := (FMsgList.Count > 0); // Ϣ
  finally
    FLock.Release;
  end;
  if Trigger then
    ReleaseSemapHore(FSemaphore, 8, Nil);
end;

function TPushMsgManager.AddWork(Msg: TPushMessage): Boolean;
  function GetTickCountDiff: Boolean;
  begin
    if (FNowTickCount >= FTickCount) then
      Result := FNowTickCount - FTickCount >= 1000  // һ
    else
      Result := High(Cardinal) - FTickCount + FNowTickCount >= 1000;
  end;
begin
  // һϢ
  // ٶȿƣÿ FMaxPushCount Σ
  //           ϢѻʱҲ

  Result := True;
  FLock.Acquire;

  try
    if (FMaxPushCount > 0) then
    begin
      if (FPushMsgCount > FMaxPushCount div 5) then // Ϣѻ豸ܵ
        Result := False
      else begin
        FNowTickCount := GetTickCount;
        if GetTickCountDiff then  // ʱ 1 
        begin
          FTickCount := FNowTickCount;
          Result := (FPushCountPS <= FMaxPushCount); // û
          FPushCountPS := 0;
        end;
      end;
    end;
    if Result then  // ͳ
    begin
      // 
      FActiveCount := FMsgList.Count;
      // ÿϢ
      Inc(FPushCountPS, Msg.FClientCount);
    end;
  finally
    FLock.Release;
  end;

  if Result then
    FPushPool.InterAdd(Msg)  // ȼ
  else // ͷţ
    Msg.Free;

end;

constructor TPushMsgManager.Create(ABusiManger: TBusiWorkManager; AThreadCount, AMaxPushCount: Integer);
var
  i: Integer;
begin
  inherited Create;

  // 1. źŵƣֵ = MaxInt
  FSemaphore := CreateSemapHore(Nil, 0, MaxInt, Nil);
  FWaitSemaphore := CreateSemapHore(Nil, 0, MaxInt, Nil);

  // 2. б
  FLock := TThreadLock.Create;
  FPushPool := TMsgPushPool.Create(Self);  // Ϣ
  FMsgList := TInList.Create;  // Ϣб

  // 3. ߳ÿ
  FThreadCount := AThreadCount;
  FMaxPushCount := AMaxPushCount;

  SetLength(FThreads, FThreadCount);

  for i := 0 to High(FThreads) do
  begin
    FThreads[i] := TPushThread.Create(Self, ABusiManger);
    FThreads[i].Resume;
  end;

  // 4.  FPushPoolֹͣʱͷ FPushPool
  InterlockedIncrement(FThreadCount);
end;

destructor TPushMsgManager.Destroy;
begin
  StopThreads;
  inherited;
end;

function TPushMsgManager.GetWork(var Msg: TPushMessage): Boolean;
begin
  // ȡһϢ
  FLock.Acquire;
  try
    Msg := FMsgList.PopFirst;
    if (Msg = nil) then
    begin
      FActiveCount := 0;
      Result := False;
    end else
    begin
      FActiveCount := FMsgList.Count;
      Dec(FPushMsgCount, Msg.FClientCount);  // -      
      Result := True;
    end;
  finally
    FLock.Release;
  end;
end;

procedure TPushMsgManager.InterAdd(Msg: TPushMessage);
begin
  // ʽϢͶ
  FLock.Acquire;
  try
    // 
    if (Msg.FCastType > btUnknown) then
      Msg.FClientCount := Msg.FObjPool.UsedCount
    else
      Msg.FClientCount := 1;
    Inc(FPushMsgCount, Msg.FClientCount);
    FMsgList.Add(Msg);
  finally
    FLock.Release;
  end;
end;

procedure TPushMsgManager.StopThreads;
var
  i: Integer;
begin
  if Assigned(FLock) then
  begin
    // ͷ
    FPushPool.Terminate;
    
    // ֹͣȫ߳
    for i := 0 to High(FThreads) do
      FThreads[i].Stop;

    // ȴȫ߳˳
    while (FThreadCount > 0) do
    begin
      ReleaseSemapHore(FSemaphore, 1, Nil);
      Sleep(10);
    end;

    SetLength(FThreads, 0);
    CloseHandle(FSemaphore);  // ر
    CloseHandle(FWaitSemaphore);  // ر

    // ͷδ͵Ϣռ
    for i := 0 to FMsgList.Count - 1 do
      TPushMessage(FMsgList.PopFirst).Free;

    FMsgList.Free;
    FLock.Free;

    FPushPool := nil;
    FMsgList := nil;
    FLock := nil;
  end;
end;

procedure TPushMsgManager.WaitFor;
begin
  // ȴ߳̽
  while (FActiveThreadCount > 0) do
    Sleep(10);
end;

end.
