unit frmInIOCPFileServer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, fmIOCPSvrInfo, iocp_base, iocp_clients, iocp_server,
  iocp_sockets, iocp_managers, iocp_msgPacks;

type
  TFormInIOCPFileServer = class(TForm)
    Memo1: TMemo;
    InIOCPServer1: TInIOCPServer;
    btnStart: TButton;
    btnStop: TButton;
    InClientManager1: TInClientManager;
    InFileManager1: TInFileManager;
    InMessageManager1: TInMessageManager;
    FrameIOCPSvrInfo1: TFrameIOCPSvrInfo;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure InClientManager1Login(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure FormCreate(Sender: TObject);
    procedure InFileManager1BeforeDownload(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InFileManager1BeforeUpload(Sender: TObject;
      Params: TReceiveParams; Result: TReturnResult);
    procedure InFileManager1QueryFiles(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InFileManager1AfterDownload(Sender: TObject;
      Params: TReceiveParams; Document: TIOCPDocument);
    procedure InFileManager1AfterUpload(Sender: TObject; Params: TReceiveParams;
      Document: TIOCPDocument);
    procedure InFileManager1DeleteFile(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InFileManager1RenameFile(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InFileManager1SetWorkDir(Sender: TObject; Params: TReceiveParams;
      Result: TReturnResult);
    procedure InIOCPServer1AfterOpen(Sender: TObject);
    procedure InIOCPServer1AfterClose(Sender: TObject);
  private
    { Private declarations }
    FAppDir: String;
  public
    { Public declarations }
  end;

var
  FormInIOCPFileServer: TFormInIOCPFileServer;

implementation

uses
  iocp_log, iocp_varis, iocp_utils;

{$R *.dfm}

procedure TFormInIOCPFileServer.btnStartClick(Sender: TObject);
begin
  // עInFileManager1.ShareStream = True Թļ
  Memo1.Lines.Clear;
  iocp_log.TLogThread.InitLog;              // ־
  InIOCPServer1.Active := True;               // 
  FrameIOCPSvrInfo1.Start(InIOCPServer1);     // ʼͳ
end;

procedure TFormInIOCPFileServer.btnStopClick(Sender: TObject);
begin
  InIOCPServer1.Active := False;   // ֹͣ
  FrameIOCPSvrInfo1.Stop;          // ֹͣͳ
  iocp_log.TLogThread.StopLog;   // ֹͣ־
end;

procedure TFormInIOCPFileServer.FormCreate(Sender: TObject);
begin
  // ׼·
  FAppDir := ExtractFilePath(Application.ExeName);
  iocp_utils.IniDateTimeFormat;    // ʱʽ
    
  // ͻݴ·2.0ƣ
  iocp_Varis.gUserDataPath := FAppDir + 'client_data\';

  MyCreateDir(FAppDir + 'log');    // Ŀ¼
  MyCreateDir(FAppDir + 'temp');   // Ŀ¼

  // Եû·
  MyCreateDir(iocp_Varis.gUserDataPath);  // Ŀ¼

  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\data');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\msg');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_a\temp');

  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\data');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\msg');
  MyCreateDir(iocp_Varis.gUserDataPath + 'user_b\temp');

end;

procedure TFormInIOCPFileServer.InClientManager1Login(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  if (Params.Password <> '') then 
  begin
    Result.Role := crAdmin;     // Թ㲥ҪõȨޣ2.0ģ
    Result.ActResult := arOK;

    // Ǽ, Զû·עʱ
    InClientManager1.Add(Params.Socket, crAdmin);

    // ϢʱҪ루ļ
  end else
    Result.ActResult := arFail;
end;

procedure TFormInIOCPFileServer.InFileManager1AfterDownload(Sender: TObject;
  Params: TReceiveParams; Document: TIOCPDocument);
begin
  memo1.Lines.Add('ϣ' + ExtractFileName(Document.FileName));
end;

procedure TFormInIOCPFileServer.InFileManager1AfterUpload(Sender: TObject;
  Params: TReceiveParams; Document: TIOCPDocument);
begin
  // ϴļ
  //   Sender: TBusiWorker
  //   SocketTIOCPSocket
  // DocumentTIOCPDocument

  //   ϴʽatFileUploadatFileSendTo
  //    Document.UserName Ϊգ
  //  ˵ǻļҪ֪ͨԷػ򱣴ϢԷ¼ʱȡ

  memo1.Lines.Add('ϴϣ' + ExtractFileName(Document.FileName));

  // °ͷToUser бֱӵüɣ
  if (Params.ToUser <> '') then  // ļ֪ͨ ToUser 
    InMessageManager1.PushMsg(Params, Params.ToUser);  // ѻ򱣴浽ļ

end;

procedure TFormInIOCPFileServer.InFileManager1BeforeDownload(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ļҪʹ·
  if (Params.Action = atFileDownChunk) then
  begin
    // شļ
    memo1.Lines.Add('׼أ' + 'F:\Backup\jdk-8u77-windows-i586.exe');  // F:\Backup\Ghost\WIN-7-20190228.GHO
    InFileManager1.OpenLocalFile(Result, 'F:\Backup\jdk-8u77-windows-i586.exe'); // F:\Backup\Ghost\WIN-7-20190228.GHO
  end else
  begin
    memo1.Lines.Add('׼أ' + 'F:\Backup\jdk-8u77-windows-i586.exe'); // gUserDataPath + Params.FileName);
    InFileManager1.OpenLocalFile(Result, 'F:\Backup\jdk-8u77-windows-i586.exe');
  end;
end;

procedure TFormInIOCPFileServer.InFileManager1BeforeUpload(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ϴļû·
  //   2.0 ڲԶжļǷڣһļ
  Memo1.Lines.Add('׼ϴ: ' + Params.FileName);

  // ¼ʹַգ
  // Params.CreateAttachment('·');
 
  InFileManager1.CreateNewFile(Params);
end;

procedure TFormInIOCPFileServer.InFileManager1DeleteFile(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ɾļӦڿͻȷ
  if DeleteFile(Params.Socket.Envir^.WorkDir + Params.FileName) then
    Result.ActResult := arOK
  else
    Result.ActResult := arFail;
end;

procedure TFormInIOCPFileServer.InFileManager1QueryFiles(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ѯǰĿ¼µļ
  InFileManager1.ListFiles(Params, Result);
end;

procedure TFormInIOCPFileServer.InFileManager1RenameFile(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ĹĿ¼µļ
  if RenameFile(Params.Socket.Envir^.WorkDir + Params.FileName,
                Params.Socket.Envir^.WorkDir + Params.NewFileName) then
    Result.ActResult := arOK
  else
    Result.ActResult := arFail;
end;

procedure TFormInIOCPFileServer.InFileManager1SetWorkDir(Sender: TObject;
  Params: TReceiveParams; Result: TReturnResult);
begin
  // ùĿ¼ܳĹĿ¼Χ
//  if True then
    InFileManager1.SetWorkDir(Result, Params.Directory);  // 2.0 
//  else
//    Result.ActResult := arFail;
end;

procedure TFormInIOCPFileServer.InIOCPServer1AfterClose(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
end;

procedure TFormInIOCPFileServer.InIOCPServer1AfterOpen(Sender: TObject);
begin
  btnStart.Enabled := not InIOCPServer1.Active;
  btnStop.Enabled := InIOCPServer1.Active;
  memo1.Lines.Add('IP:' + InIOCPServer1.ServerAddr);
  memo1.Lines.Add('Port:' + IntToStr(InIOCPServer1.ServerPort));
end;

end.
